{
 Betsy computer chess engine
 Landon W. Rabern, 1999
}
uses crt,timer;
const
  tmaxtime=500;
  fmaxtime=500;
  maxkillers=50;
  bp:set of char=['r','h','b','p','q','k'];
  wp:set of char=['R','H','B','P','Q','K'];
  pc=1000;
  bc=3000;
  hc=3000;
  qc=9000;
  rc=5000;
type
  Tmove=array[1..4] of shortint;
  Tboard=array[1..8,1..8] of char;
  Tmoves=array[-1..500] of Tmove;
  Pboard=^Tboard;
  Pmoves=^Tmoves;
  Tcastle=record
    cqst,ckst,cqsf,cksf,castledt,castledf:boolean;
  end;
var
   board:Pboard;
   cmove,enp,bm:Tmove;
   castle,castletmp,fc:Tcastle;
   moves:Pmoves;
   maxlevels,lgot,i,j,scr,mc,levels,ne,qne,wtime,btime,ks,ks2,bv,hd:longint;
   turn,lg,wascap:boolean;
   green:array[1..8,1..8] of boolean;
   inp:string;
   w:array[1..10,1..5] of longint;
   killer:array[0..1,1..maxkillers] of Tmove;

function legal(board:Pboard;mv:Tmove;trn:boolean):boolean; forward;
procedure go(var board:Pboard;gmove:Tmove;var cas:Tcastle);forward;
function eval(brd:Pboard;player:boolean;cas:Tcastle):longint;forward;
function eval2(brd:Pboard;player:boolean;cas:Tcastle):longint;forward;
procedure movegen(brd:Pboard;var ma:Pmoves;var num:longint;player:boolean;cas:Tcastle);forward;
procedure gencap(brd:Pboard;var ma:Pmoves;var cc:longint;player:boolean);forward;
function startcomp(brd:Pboard;posmov:Pmoves;player:boolean;cas:Tcastle;var bmsf:Tmove;num:longint):boolean;forward;
function startcomp2(brd:Pboard;posmov:Pmoves;player:boolean;cas:Tcastle;var bmsf:Tmove;num:longint):boolean;forward;

procedure setup(var board:Pboard);
var
  i,j:longint;
  f:text;
  s:string;
begin
  randomize;
  assign(f,'start.map');
  reset(f);
  new(board);
  new(moves);
  readln(f,s);
  castle.cqst:=(s='TRUE');
  readln(f,s);
  castle.ckst:=(s='TRUE');
  readln(f,s);
  castle.cqsf:=(s='TRUE');
  readln(f,s);
  castle.cksf:=(s='TRUE');
  castle.castledt:=false;
  castle.castledf:=false;
  for i:=8 downto 1 do
    begin
      readln(f,s);
      for j:=1 to 8 do
        board^[j,i]:=s[j];
    end;
  close(f);
  assign(f,'weights.lst');
  reset(f);
  i:=1;
  readln(f);
  for j:=1 to 5 do
    readln(f,w[i,j]);
  close(f);
  turn:=false;
  mc:=1;
  textattr:=15;
  ks:=0;
  ks2:=1-ks;
  fc.cqst:=false;
  fc.ckst:=false;
  fc.cqsf:=false;
  fc.cksf:=false;
end;

procedure done;
var
  f:text;
begin
  textattr:=15;
  assign(f,'save.map');
  rewrite(f);
  writeln(f,castle.cqst);
  writeln(f,castle.ckst);
  writeln(f,castle.cqsf);
  writeln(f,castle.cksf);

  for i:=8 downto 1 do
    begin
      for j:=1 to 8 do
        write(f,board^[j,i]);
      writeln(f);
    end;
  writeln(f);
  for i:=1 to pred(mc) do
    begin
      if odd(i) then write(f,'W ')
      else write(f,'B ');
      write(f,moves^[i][1]);
      write(f,moves^[i][2]);
      write(f,moves^[i][3]);
      write(f,moves^[i][4]);
      writeln(f);
    end;
  close(f);
  dispose(board);
  dispose(moves);
  halt;
end;

function pval(p:char):longint;
begin
  case upcase(p) of
    'P':pval:=1000;
    'B','H':pval:=3000;
    'R':pval:=5000;
    'Q':pval:=9000;
  end;
end;

procedure drawboard(board:Pboard);
var
   i,j:longint;
begin
  textattr:=15;
  for i:=1 to 8 do
    begin
      gotoxy(1,9-i);
      write(i);
    end;
  gotoxy(2,9);
  for i:=1 to 8 do
    write(' ',chr(i+ord('a')-1),' ');
  for i:=1 to 8 do
    begin
      gotoxy(2,i);
      for j:=1 to 8 do
        begin
          if green[j,9-i] then
            textattr:=2*16
          else
          if odd(i) xor odd(j) then
            textattr:=0
          else
          textattr:=6*16;
          if board^[j,9-i]<>'e' then
            begin
              if ord(board^[j,9-i])>90 then
                begin
                  textattr:=textattr+7;
                  write(' ',board^[j,9-i],' ');
                 end
                else
                  begin
                    textattr:=textattr+15;
                    write(' ',board^[j,9-i],' ');
                  end;
            end
          else
            write('   ');
        end;
    textattr:=0;
    end;
  textattr:=15;
end;

function check(brd:Pboard;king:char):boolean;
label out;
var
  i,j,kx,ky:longint;
begin
  check:=false;
  for i:=1 to 8 do
    for j:=1 to 8 do
      if brd^[i,j]=king then
        begin
          kx:=i;
          ky:=j;
          goto out;
        end;
  out:
  if ord(king)>90 then
    begin
      if kx<8 then
        begin
          i:=succ(kx);
          while (i<8) and (brd^[i,ky]='e') do
            inc(i);
          if brd^[i,ky] in ['Q','R'] then
            begin
              check:=true;
              exit;
            end;
          if ky<8 then
            begin
              i:=succ(kx);
              j:=succ(ky);
              while (i<8) and (j<8) and (brd^[i,j]='e') do
                begin
                  inc(i);
                  inc(j);
                end;
              if brd^[i,j] in ['Q','B'] then
                begin
                  check:=true;
                  exit;
                end;
            end;
          if ky>1 then
            begin
              i:=succ(kx);
              j:=pred(ky);
              while (i<8) and (j>1) and (brd^[i,j]='e') do
                begin
                  inc(i);
                  dec(j);
                end;
              if brd^[i,j] in ['Q','B'] then
                begin
                  check:=true;
                  exit;
                end;
            end;
        end;
      if kx>1 then
        begin
          i:=pred(kx);
          while (i>1) and (brd^[i,ky]='e') do
            dec(i);
          if brd^[i,ky] in ['Q','R'] then
            begin
              check:=true;
              exit;
            end;
          if ky<8 then
            begin
              i:=pred(kx);
              j:=succ(ky);
              while (i>1) and (j<8) and (brd^[i,j]='e') do
                begin
                  dec(i);
                  inc(j);
                end;
              if brd^[i,j] in ['Q','B'] then
                begin
                  check:=true;
                  exit;
                end;
            end;
          if ky>1 then
            begin
              i:=pred(kx);
              j:=pred(ky);
              while (i>1) and (j>1) and (brd^[i,j]='e') do
                begin
                  dec(i);
                  dec(j);
                end;
              if brd^[i,j] in ['Q','B'] then
                begin
                  check:=true;
                  exit;
                end;
            end;
        end;
      if ky<8 then
        begin
          i:=succ(ky);
          while (i<8) and (brd^[kx,i]='e') do
            inc(i);
          if brd^[kx,i] in ['Q','R'] then
            begin
              check:=true;
              exit;
            end;
        end;
      if ky>1 then
        begin
          i:=pred(ky);
          while (i>1) and (brd^[kx,i]='e') do
            dec(i);
          if brd^[kx,i] in ['Q','R'] then
            begin
              check:=true;
              exit;
            end;
        end;
      if ((kx<7) and (ky>1) and (brd^[kx+2,pred(ky)]='H')) or
         ((kx<7) and (ky<8) and (brd^[kx+2,succ(ky)]='H')) or
         ((kx>2) and (ky>1) and (brd^[kx-2,pred(ky)]='H')) or
         ((kx>2) and (ky<8) and (brd^[kx-2,succ(ky)]='H')) or
         ((kx>1) and (ky<7) and (brd^[pred(kx),ky+2]='H')) or
         ((kx<8) and (ky<7) and (brd^[succ(kx),ky+2]='H')) or
         ((kx>1) and (ky>2) and (brd^[pred(kx),ky-2]='H')) or
         ((kx<8) and (ky>2) and (brd^[succ(kx),ky-2]='H')) or
         ((kx<8) and (ky>1) and (brd^[succ(kx),pred(ky)] in ['P','K'])) or
         ((kx>1) and (ky>1) and (brd^[pred(kx),pred(ky)] in ['P','K'])) or
         ((ky>1) and (brd^[kx,pred(ky)]='K')) or
         ((kx<8) and (brd^[succ(kx),ky]='K')) or
         ((kx>1) and (brd^[pred(kx),ky]='K')) or
         ((ky<8) and (brd^[kx,succ(ky)]='K')) or
         ((ky<8) and (kx>1) and (brd^[pred(kx),succ(ky)]='K')) or
         ((ky<8) and (kx<8) and (brd^[succ(kx),succ(ky)]='K')) then
        begin
          check:=true;
          exit;
        end;
    end
  else
    begin
      if kx<8 then
        begin
          i:=succ(kx);
          while (i<8) and (brd^[i,ky]='e') do
            inc(i);
          if brd^[i,ky] in ['q','r'] then
            begin
              check:=true;
              exit;
            end;
          if ky<8 then
            begin
              i:=succ(kx);
              j:=succ(ky);
              while (i<8) and (j<8) and (brd^[i,j]='e') do
                begin
                  inc(i);
                  inc(j);
                end;
              if brd^[i,j] in ['q','b'] then
                begin
                  check:=true;
                  exit;
                end;
            end;
          if ky>1 then
            begin
              i:=succ(kx);
              j:=pred(ky);
              while (i<8) and (j>1) and (brd^[i,j]='e') do
                begin
                  inc(i);
                  dec(j);
                end;
              if brd^[i,j] in ['q','b'] then
                begin
                  check:=true;
                  exit;
                end;
            end;
        end;
      if kx>1 then
        begin
          i:=pred(kx);
          while (i>1) and (brd^[i,ky]='e') do
            dec(i);
          if brd^[i,ky] in ['q','r'] then
            begin
              check:=true;
              exit;
            end;
          if ky<8 then
            begin
              i:=pred(kx);
              j:=succ(ky);
              while (i>1) and (j<8) and (brd^[i,j]='e') do
                begin
                  dec(i);
                  inc(j);
                end;
              if brd^[i,j] in ['q','b'] then
                begin
                  check:=true;
                  exit;
                end;
            end;
          if ky>1 then
            begin
              i:=pred(kx);
              j:=pred(ky);
              while (i>1) and (j>1) and (brd^[i,j]='e') do
                begin
                  dec(i);
                  dec(j);
                end;
              if brd^[i,j] in ['q','b'] then
                begin
                  check:=true;
                  exit;
                end;
            end;
        end;
      if ky<8 then
        begin
          i:=succ(ky);
          while (i<8) and (brd^[kx,i]='e') do
            inc(i);
          if brd^[kx,i] in ['q','r'] then
            begin
              check:=true;
              exit;
            end;
        end;
      if ky>1 then
        begin
          i:=pred(ky);
          while (i>1) and (brd^[kx,i]='e') do
            dec(i);
          if brd^[kx,i] in ['q','r'] then
            begin
              check:=true;
              exit;
            end;
        end;
      if ((kx<7) and (ky>1) and (brd^[kx+2,pred(ky)]='h')) or
         ((kx<7) and (ky<8) and (brd^[kx+2,succ(ky)]='h')) or
         ((kx>2) and (ky>1) and (brd^[kx-2,pred(ky)]='h')) or
         ((kx>2) and (ky<8) and (brd^[kx-2,succ(ky)]='h')) or
         ((kx>1) and (ky<7) and (brd^[pred(kx),ky+2]='h')) or
         ((kx<8) and (ky<7) and (brd^[succ(kx),ky+2]='h')) or
         ((kx>1) and (ky>2) and (brd^[pred(kx),ky-2]='h')) or
         ((kx<8) and (ky>2) and (brd^[succ(kx),ky-2]='h')) or
         ((kx<8) and (ky>1) and (brd^[succ(kx),pred(ky)]='k')) or
         ((kx>1) and (ky>1) and (brd^[pred(kx),pred(ky)]='k')) or
         ((ky>1) and (brd^[kx,pred(ky)]='k')) or
         ((kx<8) and (brd^[succ(kx),ky]='k')) or
         ((kx>1) and (brd^[pred(kx),ky]='k')) or
         ((ky<8) and (brd^[kx,succ(ky)]='k')) or
         ((ky<8) and (kx>1) and (brd^[pred(kx),succ(ky)] in ['k','p'])) or
         ((ky<8) and (kx<8) and (brd^[succ(kx),succ(ky)] in ['k','p'])) then
        begin
          check:=true;
          exit;
        end;
    end;
end;

function removecheck(brd:Pboard;king:char;move:Tmove):boolean;
var
  temp:Pboard;
  dc:Tcastle;
begin
  removecheck:=false;
  new(temp);
  temp^:=brd^;
  go(temp,move,dc);
  removecheck:=(not check(temp,king));
  dispose(temp);
end;

function mate(board:Pboard;king:char):boolean;
var
  i,j,k,l:longint;
  mv:Tmove;
  tcas:Tcastle;
begin
  tcas:=castle;
  if not check(board,king) then
    begin
      mate:=false;
      exit;
    end;
  mate:=true;
  if ord(king)>90 then
    begin
      for i:=1 to 8 do
        begin
          mv[1]:=i;
          for j:=1 to 8 do
            begin
              mv[2]:=j;
              if board^[i,j] in bp then
                for k:=1 to 8 do
                  begin
                    mv[3]:=k;
                    for l:=1 to 8 do
                      begin
                        mv[4]:=l;
                        if (legal(board,mv,true)) and (removecheck(board,'k',mv)) then
                          begin
                            mate:=false;
                            castle:=tcas;
                            exit;
                          end;
                      end;
                  end;
            end;
        end;
    end
  else
    begin
      for i:=1 to 8 do
        begin
          mv[1]:=i;
          for j:=1 to 8 do
            begin
              mv[2]:=j;
              if board^[i,j] in wp then
                for k:=1 to 8 do
                  begin
                    mv[3]:=k;
                    for l:=1 to 8 do
                      begin
                      mv[4]:=l;
                      if (legal(board,mv,false)) and (removecheck(board,'K',mv)) then
                        begin
                          mate:=false;
                          castle:=tcas;
                          exit;
                        end;
                      end;
                  end;
            end;
        end;
    end;
  castle:=tcas;
end;

function legal(board:Pboard;mv:Tmove;trn:boolean):boolean;
var
  i:longint;
  jib:boolean;
  kmm:Tmove;
begin
  if (mv[1]=mv[3]) and (mv[2]=mv[4]) then
    begin
      legal:=false;
      exit;
    end;
  if trn then {if whites turn}
    begin
      case board^[mv[1],mv[2]] of
        'R','H','B','P','Q','K','e':begin
          legal:=false;
        end;
        'r':begin
             if mv[1]=mv[3] then
              begin
                jib:=true;
                if mv[2]<mv[4] then
                  begin
                    for i:=mv[2]+1 to mv[4] do
                      begin
                        if (board^[mv[3],i] in wp) and (i=mv[4]) then
                          else if board^[mv[3],i]<>'e' then jib:=false;
                      end;
                  end
                else
                  begin
                    for i:=mv[2]-1 downto mv[4] do
                      begin
                        if (board^[mv[3],i] in wp) and (i=mv[4]) then
                          else if board^[mv[3],i]<>'e' then jib:=false;
                      end;
                  end;
              end
             else if mv[2]=mv[4] then
              begin
                jib:=true;
                if mv[1]<mv[3] then
                  begin
                    for i:=succ(mv[1]) to mv[3] do
                      begin
                        if (board^[i,mv[4]] in wp) and (i=mv[3]) then
                          else if board^[i,mv[4]]<>'e' then jib:=false;
                      end;
                  end
                else
                  for i:=mv[1]-1 downto mv[3] do
                    begin
                      if (board^[i,mv[4]] in wp) and (i=mv[3]) then
                          else if board^[i,mv[4]]<>'e' then jib:=false;
                    end;
              end
             else jib:=false;
             legal:=jib;
            end;
        'h':begin
              legal:=false;
              if (board^[mv[3],mv[4]] in ['R','H','B','P','Q','K','e']) and
                   (((mv[3]-mv[1]=2) and (mv[4]-mv[2]=1)) or
                   ((mv[3]-mv[1]=2) and (mv[4]-mv[2]=-1)) or
                   ((mv[3]-mv[1]=-2) and (mv[4]-mv[2]=1)) or
                   ((mv[3]-mv[1]=-2) and (mv[4]-mv[2]=-1)) or
                   ((mv[3]-mv[1]=1) and (mv[4]-mv[2]=2)) or
                   ((mv[3]-mv[1]=1) and (mv[4]-mv[2]=-2)) or
                   ((mv[3]-mv[1]=-1) and (mv[4]-mv[2]=2)) or
                   ((mv[3]-mv[1]=-1) and (mv[4]-mv[2]=-2))) then
                legal:=true;
            end;

        'b':if abs(mv[2]-mv[4])=abs(mv[3]-mv[1]) then
              begin
                legal:=true;
                if mv[1]<mv[3] then
                  begin
                    if mv[2]<mv[4] then
                      begin
                        for i:=1 to mv[3]-mv[1] do
                          if (board^[i+mv[1],i+mv[2]] in wp) and
                             (i+mv[1]=mv[3]) and (i+mv[2]=mv[4]) then
                          else if board^[i+mv[1],i+mv[2]]<>'e' then legal:=false;
                      end
                    else
                      begin
                        for i:=1 to mv[3]-mv[1] do
                          if (board^[i+mv[1],mv[2]-i] in wp) and
                             (i+mv[1]=mv[3]) and (mv[2]-i=mv[4]) then
                          else if board^[i+mv[1],mv[2]-i]<>'e' then legal:=false;
                      end;
                  end
                else
                  begin
                    if mv[2]<mv[4] then
                      begin
                        for i:=1 to mv[1]-mv[3] do
                          if (board^[mv[1]-i,i+mv[2]] in wp) and
                             (mv[1]-i=mv[3]) and (i+mv[2]=mv[4]) then
                          else if board^[mv[1]-i,i+mv[2]]<>'e' then legal:=false;
                      end
                    else
                      begin
                        for i:=1 to mv[1]-mv[3] do
                          if (board^[mv[1]-i,mv[2]-i] in wp) and
                             (mv[1]-i=mv[3]) and (mv[2]-i=mv[4]) then
                          else if board^[mv[1]-i,mv[2]-i]<>'e' then legal:=false;
                      end;
                  end;
              end
            else legal:=false;
        'p':if mv[1]=mv[3] then
              begin
                if mv[4]=pred(mv[2]) then
                  begin
                    if board^[mv[3],mv[4]]='e' then
                      legal:=true
                    else legal:=false;
                  end
                else if (mv[4]=5) and (mv[2]=7) then
                  begin
                    if (board^[mv[3],mv[4]]='e') and
                       (board^[mv[3],mv[4]+1]='e') then
                      legal:=true
                    else legal:=false;
                  end
                else
                  begin
                    legal:=false;
                  end;
              end
            else
              begin
                legal:=false;
                if mv[4]=pred(mv[2]) then
                  begin
                    if (mv[1]=pred(mv[3])) or (mv[1]=succ(mv[3])) then
                      begin
                        if not (board^[mv[3],mv[4]] in
                        ['r','h','b','p','q','k','e']) then
                          legal:=true
                        else
                        {en passant}
                        if (board^[mv[3],succ(mv[4])]='P')
                           and (moves^[pred(mc)][1]=mv[3]) and
                               (moves^[pred(mc)][2]=pred(mv[4])) and
                               (moves^[pred(mc)][3]=mv[3]) and
                               (moves^[pred(mc)][4]=succ(mv[4])) then
                            begin
                              legal:=true;
                              enp[1]:=mv[3];
                              enp[2]:=mv[4];
                            end;
                      end;
                  end;
              end;
        'q':{horizontal and vertical movement}
            if mv[1]=mv[3] then
              begin
                legal:=true;
                if mv[2]<mv[4] then
                  begin
                    for i:=mv[2]+1 to mv[4] do
                      begin
                        if (board^[mv[3],i] in wp) and (i=mv[4]) then
                          else if board^[mv[3],i]<>'e' then legal:=false;
                      end;
                  end
                else
                  begin
                    for i:=mv[2]-1 downto mv[4] do
                      begin
                        if (board^[mv[3],i] in wp) and (i=mv[4]) then
                          else if board^[mv[3],i]<>'e' then legal:=false;
                      end;
                  end;
              end
            else if mv[2]=mv[4] then
              begin
                legal:=true;
                if mv[1]<mv[3] then
                  begin
                    for i:=mv[1]+1 to mv[3] do
                      begin
                        if (board^[i,mv[4]] in wp) and (i=mv[3]) then
                          else if board^[i,mv[4]]<>'e' then legal:=false;
                      end;
                  end
                else
                  for i:=mv[1]-1 downto mv[3] do
                    begin
                      if (board^[i,mv[4]] in wp) and (i=mv[3]) then
                          else if board^[i,mv[4]]<>'e' then legal:=false;
                    end;
              end
            else
            {diagonal movement}
            if abs(mv[2]-mv[4])=abs(mv[3]-mv[1]) then
              begin
                legal:=true;
                if mv[1]<mv[3] then
                  begin
                    if mv[2]<mv[4] then
                      begin
                        for i:=1 to mv[3]-mv[1] do
                          if (board^[i+mv[1],i+mv[2]] in wp) and
                             (i+mv[1]=mv[3]) and (i+mv[2]=mv[4]) then
                          else if board^[i+mv[1],i+mv[2]]<>'e' then legal:=false;
                      end
                    else
                      begin
                        for i:=1 to mv[3]-mv[1] do
                          if (board^[i+mv[1],mv[2]-i] in wp) and
                             (i+mv[1]=mv[3]) and (mv[2]-i=mv[4]) then
                          else if board^[i+mv[1],mv[2]-i]<>'e' then legal:=false;
                      end;
                  end
                else
                  begin
                    if mv[2]<mv[4] then
                      begin
                        for i:=1 to mv[1]-mv[3] do
                          if (board^[mv[1]-i,i+mv[2]] in wp) and
                             (mv[1]-i=mv[3]) and (i+mv[2]=mv[4]) then
                          else if board^[mv[1]-i,i+mv[2]]<>'e' then legal:=false;
                      end
                    else
                      begin
                        for i:=1 to mv[1]-mv[3] do
                          if (board^[mv[1]-i,mv[2]-i] in wp) and
                             (mv[1]-i=mv[3]) and (mv[2]-i=mv[4]) then
                          else if board^[mv[1]-i,mv[2]-i]<>'e' then legal:=false;
                      end;
                  end;
              end
            else legal:=false;
        'k':begin
              legal:=false;
              if ((board^[mv[3],mv[4]] in ['R','H','B','P','Q','K','e']) and
                 (abs(mv[3]-mv[1])<2) and (abs(mv[4]-mv[2])<2)) then
                begin
                  legal:=true;
                end
              else
                begin
                  kmm:=mv;
                  kmm[3]:=mv[1]+(mv[3]-mv[1]) div 2;
                  if (board^[mv[3],mv[4]]='e')
                  and (mv[2]=mv[4]) and (abs(mv[3]-mv[1])=2)
                       and (board^[mv[1]+(mv[3]-mv[1]) div 2,mv[4]]='e') and
                       ((removecheck(board,'k',mv)) or
                       (removecheck(board,'k',kmm))) then
                         begin
                           if (mv[1]=5) and (mv[3]=3) and (mv[2]=8) and (castle.cqst) then
                             begin
                               legal:=true;
                             end;
                           if (mv[1]=5) and (mv[3]=7) and (mv[2]=8) and (castle.ckst) then
                             begin
                               legal:=true;
                             end;
                         end;
                end;
            end;
      end;
    end
  else {if blacks turn}
    begin
      case board^[mv[1],mv[2]] of
        'r','h','b','p','q','k','e':begin
          legal:=false;
        end;
        'R':begin
             if mv[1]=mv[3] then
              begin
                jib:=true;
                if mv[2]<mv[4] then
                  begin
                    for i:=mv[2]+1 to mv[4] do
                      begin
                        if (board^[mv[3],i] in bp) and (i=mv[4]) then
                          else if board^[mv[3],i]<>'e' then jib:=false;
                      end;
                  end
                else
                  begin
                    for i:=mv[2]-1 downto mv[4] do
                      begin
                        if (board^[mv[3],i] in bp) and (i=mv[4]) then
                          else if board^[mv[3],i]<>'e' then jib:=false;
                      end;
                  end;
              end
             else if mv[2]=mv[4] then
              begin
                jib:=true;
                if mv[1]<mv[3] then
                  begin
                    for i:=mv[1]+1 to mv[3] do
                      begin
                        if (board^[i,mv[4]] in bp) and (i=mv[3]) then
                          else if board^[i,mv[4]]<>'e' then jib:=false;
                      end;
                  end
                else
                  for i:=mv[1]-1 downto mv[3] do
                    begin
                      if (board^[i,mv[4]] in bp) and (i=mv[3]) then
                          else if board^[i,mv[4]]<>'e' then jib:=false;
                    end;
              end
             else jib:=false;
             legal:=jib;
            end;
        'H':begin
              legal:=false;
              if (board^[mv[3],mv[4]] in ['r','h','b','p','q','k','e']) and
                   (((mv[3]-mv[1]=2) and (mv[4]-mv[2]=1)) or
                   ((mv[3]-mv[1]=2) and (mv[4]-mv[2]=-1)) or
                   ((mv[3]-mv[1]=-2) and (mv[4]-mv[2]=1)) or
                   ((mv[3]-mv[1]=-2) and (mv[4]-mv[2]=-1)) or
                   ((mv[3]-mv[1]=1) and (mv[4]-mv[2]=2)) or
                   ((mv[3]-mv[1]=1) and (mv[4]-mv[2]=-2)) or
                   ((mv[3]-mv[1]=-1) and (mv[4]-mv[2]=2)) or
                   ((mv[3]-mv[1]=-1) and (mv[4]-mv[2]=-2))) then
                legal:=true;
            end;
        'B':if abs(mv[2]-mv[4])=abs(mv[3]-mv[1]) then
              begin
                legal:=true;
                if mv[1]<mv[3] then
                  begin
                    if mv[2]<mv[4] then
                      begin
                        for i:=1 to mv[3]-mv[1] do
                          if (board^[i+mv[1],i+mv[2]] in bp) and
                             (i+mv[1]=mv[3]) and (i+mv[2]=mv[4]) then
                          else if board^[i+mv[1],i+mv[2]]<>'e' then legal:=false;
                      end
                    else
                      begin
                        for i:=1 to mv[3]-mv[1] do
                          if (board^[i+mv[1],mv[2]-i] in bp) and
                             (i+mv[1]=mv[3]) and (mv[2]-i=mv[4]) then
                          else if board^[i+mv[1],mv[2]-i]<>'e' then legal:=false;
                      end;
                  end
                else
                  begin
                    if mv[2]<mv[4] then
                      begin
                        for i:=1 to mv[1]-mv[3] do
                          if (board^[mv[1]-i,i+mv[2]] in bp) and
                             (mv[1]-i=mv[3]) and (i+mv[2]=mv[4]) then
                          else if board^[mv[1]-i,i+mv[2]]<>'e' then legal:=false;
                      end
                    else
                      begin
                        for i:=1 to mv[1]-mv[3] do
                          if (board^[mv[1]-i,mv[2]-i] in bp) and
                             (mv[1]-i=mv[3]) and (mv[2]-i=mv[4]) then
                          else if board^[mv[1]-i,mv[2]-i]<>'e' then legal:=false;
                      end;
                  end;
              end
            else legal:=false;
        'P':if mv[1]=mv[3] then
              begin
                if mv[4]=succ(mv[2]) then
                  begin
                    if board^[mv[3],mv[4]]='e' then
                      legal:=true
                    else legal:=false;
                  end
                else if (mv[4]=4) and (mv[2]=2) then
                  begin
                    if (board^[mv[3],mv[4]]='e') and
                       (board^[mv[3],mv[4]-1]='e') then
                      legal:=true
                    else legal:=false;
                  end
                else
                  begin
                    legal:=false;
                  end;
              end
            else
              begin
                legal:=false;
                if mv[4]=succ(mv[2]) then
                  begin
                    if (mv[1]=pred(mv[3])) or (mv[1]=succ(mv[3])) then
                      begin
                        if not (board^[mv[3],mv[4]] in
                        ['R','H','B','P','Q','K','e']) then
                          legal:=true
                        else
                        {en passant}
                        if (board^[mv[3],mv[4]-1]='p')
                           and (moves^[pred(mc)][1]=mv[3]) and
                               (moves^[pred(mc)][2]=succ(mv[4])) and
                               (moves^[pred(mc)][3]=mv[3]) and
                               (moves^[pred(mc)][4]=pred(cmove[4])) then
                            begin
                              legal:=true;
                              enp[1]:=mv[3];
                              enp[2]:=mv[4];
                            end;
                      end;
                  end;
              end;
        'Q':{horizontal and vertical movement}
            if mv[1]=mv[3] then
              begin
                legal:=true;
                if mv[2]<mv[4] then
                  begin
                    for i:=mv[2]+1 to mv[4] do
                      begin
                        if (board^[mv[3],i] in bp) and (i=mv[4]) then
                          else if board^[mv[3],i]<>'e' then legal:=false;
                      end;
                  end
                else
                  begin
                    for i:=mv[2]-1 downto mv[4] do
                      begin
                        if (board^[mv[3],i] in bp) and (i=mv[4]) then
                          else if board^[mv[3],i]<>'e' then legal:=false;
                      end;
                  end;
              end
            else if mv[2]=mv[4] then
              begin
                legal:=true;
                if mv[1]<mv[3] then
                  begin
                    for i:=mv[1]+1 to mv[3] do
                      begin
                        if (board^[i,mv[4]] in bp) and (i=mv[3]) then
                          else if board^[i,mv[4]]<>'e' then legal:=false;
                      end;
                  end
                else
                  for i:=mv[1]-1 downto mv[3] do
                    begin
                      if (board^[i,mv[4]] in bp) and (i=mv[3]) then
                          else if board^[i,mv[4]]<>'e' then legal:=false;
                    end;
              end
            else
            {diagonal movement}
            if abs(mv[2]-mv[4])=abs(mv[3]-mv[1]) then
              begin
                legal:=true;
                if mv[1]<mv[3] then
                  begin
                    if mv[2]<mv[4] then
                      begin
                        for i:=1 to mv[3]-mv[1] do
                          if (board^[i+mv[1],i+mv[2]] in bp) and
                             (i+mv[1]=mv[3]) and (i+mv[2]=mv[4]) then
                          else if board^[i+mv[1],i+mv[2]]<>'e' then legal:=false;
                      end
                    else
                      begin
                        for i:=1 to mv[3]-mv[1] do
                          if (board^[i+mv[1],mv[2]-i] in bp) and
                             (i+mv[1]=mv[3]) and (mv[2]-i=mv[4]) then
                          else if board^[i+mv[1],mv[2]-i]<>'e' then legal:=false;
                      end;
                  end
                else
                  begin
                    if mv[2]<mv[4] then
                      begin
                        for i:=1 to mv[1]-mv[3] do
                          if (board^[mv[1]-i,i+mv[2]] in bp) and
                             (mv[1]-i=mv[3]) and (i+mv[2]=mv[4]) then
                          else if board^[mv[1]-i,i+mv[2]]<>'e' then legal:=false;
                      end
                    else
                      begin
                        for i:=1 to mv[1]-mv[3] do
                          if (board^[mv[1]-i,mv[2]-i] in bp) and
                             (mv[1]-i=mv[3]) and (mv[2]-i=mv[4]) then
                          else if board^[mv[1]-i,mv[2]-i]<>'e' then legal:=false;
                      end;
                  end;
              end
            else legal:=false;
        'K':begin
              legal:=false;
              if (board^[mv[3],mv[4]] in ['r','h','b','p','q','k','e']) and
                 (abs(mv[3]-mv[1])<2) and (abs(mv[4]-mv[2])<2) then
                begin
                  legal:=true;
                end
              else
                begin
                  kmm:=mv;
                  kmm[3]:=mv[1]+(mv[3]-mv[1]) div 2;
                  if (board^[mv[3],mv[4]]='e') and (mv[2]=mv[4]) and (abs(mv[3]-mv[1])=2)
                       and (board^[mv[1]+(mv[3]-mv[1]) div 2,mv[4]]='e') and
                       (removecheck(board,'K',mv)) and
                       (removecheck(board,'K',kmm)) then
                         begin
                           if (mv[1]=5) and (mv[3]=3) and (mv[2]=1) and (castle.cqsf) then
                             begin
                               legal:=true;
                             end;
                           if (mv[1]=5) and (mv[3]=7) and (mv[2]=1) and (castle.cksf) then
                             begin
                               legal:=true;
                             end;
                         end;
                end;
            end;
      end;
    end;
end;

procedure go(var board:Pboard;gmove:Tmove;var cas:Tcastle);
begin
  wascap:=false;
  if (enp[1]=gmove[3]) and (enp[2]=gmove[4]) then
    begin
      if turn then board^[gmove[3],succ(gmove[4])]:='e'
      else board^[gmove[3],pred(gmove[4])]:='e';
    end
  else if cas.ckst and (gmove[1]=5) and (gmove[2]=8) and (gmove[3]=7) and (gmove[4]=8) then
    begin
      cas.castledt:=true;
      board^[6,8]:='r';
      board^[8,8]:='e';
    end
  else if cas.cqst and (gmove[1]=5) and (gmove[2]=8) and (gmove[3]=3) and (gmove[4]=8) then
    begin
      cas.castledt:=true;     
      board^[4,8]:='r';
      board^[1,8]:='e';
    end
  else if cas.cksf and (gmove[1]=5) and (gmove[2]=1) and (gmove[3]=7) and (gmove[4]=1) then
    begin
      cas.castledf:=true;
      board^[6,1]:='R';
      board^[8,1]:='e';
    end
  else if cas.cqsf and (gmove[1]=5) and (gmove[2]=1) and (gmove[3]=3) and (gmove[4]=1) then
    begin
      cas.castledf:=true;
      board^[4,1]:='R';
      board^[1,1]:='e';
    end
  else if (board^[gmove[1],gmove[2]]='p') and (gmove[4]=1) then
    board^[gmove[1],gmove[2]]:='q'
  else if (board^[gmove[1],gmove[2]]='P') and (gmove[4]=8) then
    board^[gmove[1],gmove[2]]:='Q';
  if board^[gmove[1],gmove[2]]='k' then
    begin
      with cas do
        begin
          ckst:=false;
          cqst:=false;
        end;
    end;
  if board^[gmove[1],gmove[2]]='K' then
    begin
      with cas do
        begin
          cksf:=false;
          cqsf:=false;
        end;
    end;
  if board^[gmove[1],gmove[2]]='r' then
    begin
      if gmove[1]=8 then cas.ckst:=false
      else if gmove[1]=1 then cas.cqst:=false;
    end;
  if board^[gmove[1],gmove[2]]='R' then
    begin
      if gmove[1]=8 then cas.cksf:=false
      else if gmove[1]=1 then cas.cqsf:=false;
    end;
  if board^[gmove[3],gmove[4]]<>'e' then wascap:=true;
  board^[gmove[3],gmove[4]]:=board^[gmove[1],gmove[2]];
  board^[gmove[1],gmove[2]]:='e';
end;

function king(player:boolean):char;
begin
  if player then king:='k'
  else king:='K';
end;

procedure id(brd:Pboard;player:boolean;cas:Tcastle);
var
  posmov,ma:Pmoves;
  temp:Pboard;
  i,n,num:longint;
  k:char;
  bmsf:Tmove;
begin
  new(posmov);
  new(ma);
  new(temp);
  movegen(brd,ma,num,player,cas);
  if player then k:='k'
  else k:='K';
  n:=0;
  for i:=1 to num do
    begin
      temp^:=brd^;
      go(temp,ma^[i],cas);
      if not check(temp,k) then
        begin
          inc(n);
          posmov^[n]:=ma^[i];
        end;
    end;
  dispose(temp);
  dispose(ma);
  starttimer;
  maxlevels:=maxkillers;
  levels:=1;
  if player then
    begin
      while levels<=maxlevels do
        begin
          writeln('Searching Depth ',levels);
          if startcomp2(brd,posmov,player,cas,bmsf,n) then
            begin
              bm:=bmsf;
              lgot:=levels;
              for i:=n downto 1 do
               if (bm[1]=posmov^[i][1]) and
                  (bm[2]=posmov^[i][2]) and
                  (bm[3]=posmov^[i][3]) and
                  (bm[4]=posmov^[i][4]) then
                 begin
                   move(posmov^[succ(i)],posmov^[i],(n-i)*sizeof(Tmove));
                   posmov^[n]:=bm;
                   break;
                 end;
            end
          else break;
          inc(levels);
        end;
    end
  else
    while levels<=maxlevels do
        begin
          writeln('Searching Depth ',levels);
          if startcomp(brd,posmov,player,cas,bmsf,n) then
            begin
              bm:=bmsf;
              lgot:=levels;
              for i:=n downto 1 do
               if (bm[1]=posmov^[i][1]) and
                  (bm[2]=posmov^[i][2]) and
                  (bm[3]=posmov^[i][3]) and
                  (bm[4]=posmov^[i][4]) then
                 begin
                   move(posmov^[succ(i)],posmov^[i],(n-i)*sizeof(Tmove));
                   posmov^[n]:=bm;
                   break;
                 end;
            end
          else break;
          inc(levels);
        end;

  dispose(posmov);
end;

function q(brd:Pboard;depth:longint;player:boolean;a,b:longint;cas:Tcastle):longint;
var
  num,value,h:longint;
  k:char;
  posmov:Pmoves;
  temp:Pboard;
  tcas:Tcastle;
begin
  inc(qne);
  new(posmov);
  gencap(brd,posmov,num,player);
  value:=-2000000000;
  if player then k:='k'
  else k:='K';
  new(temp);
  while (num>0) and (value<b) do
    begin
      temp^:=brd^;
      tcas:=cas;
      go(temp,posmov^[num],tcas);
      if not check(temp,k) then
        begin
          value:=-q(temp,succ(depth),not player,-b,-a,tcas);
          if (value>a) then a:=value;
        end;
      dec(num);
    end;
  if value=-2000000000 then
    begin
      q:=eval(brd,player,cas);
      if depth>hd then hd:=depth;
      dispose(temp);
      dispose(posmov);
      exit;
    end;
  h:=eval(brd,player,cas);
  if a>h then
    q:=a
  else q:=h;
  dispose(posmov);
  dispose(temp);
end;
function compmove(brd:Pboard;depth:longint;player:boolean;a,b:longint;cas:Tcastle):longint;
var
  num,value:longint;
  k:char;
  posmov:Pmoves;
  temp:Pboard;
  tcas:Tcastle;
begin
  if depth=levels then
    begin
      if wascap then compmove:=q(brd,depth,player,a,b,cas)
      else
        begin
          compmove:=eval(brd,player,cas);
          inc(ne);
        end;
      exit;
    end;
  inc(ne);
  new(posmov);
  movegen(brd,posmov,num,player,cas);
  for value:=num downto 1 do
    if (killer[ks][depth][1]=posmov^[value][1]) and
       (killer[ks][depth][2]=posmov^[value][2]) and
       (killer[ks][depth][3]=posmov^[value][3]) and
       (killer[ks][depth][4]=posmov^[value][4]) then
      begin
        move(posmov^[succ(value)],posmov^[value],(num-value)*sizeof(Tmove));
        posmov^[num]:=killer[ks][depth];
        break;
      end;
  for value:=num downto 1 do
    if (killer[ks2][depth][1]=posmov^[value][1]) and
       (killer[ks2][depth][2]=posmov^[value][2]) and
       (killer[ks2][depth][3]=posmov^[value][3]) and
       (killer[ks2][depth][4]=posmov^[value][4]) then
      begin
        move(posmov^[succ(value)],posmov^[value],(num-value)*sizeof(Tmove));
        posmov^[num]:=killer[ks2][depth];
        break;
      end;
  value:=-2000000000;
  if player then k:='k'
  else k:='K';
  new(temp);
  while (num>0) and (value<b) do
    begin
      temp^:=brd^;
      tcas:=cas;
      go(temp,posmov^[num],tcas);
      if not check(temp,k) then
        begin
          value:=-compmove(temp,succ(depth),not player,-b,-a,tcas);
          if (value>a) then a:=value;
        end;
      dec(num);
    end;
  if value>=b then
    begin
      if (killer[ks2][depth][1]<>posmov^[succ(num)][1]) or
         (killer[ks2][depth][2]<>posmov^[succ(num)][2]) or
         (killer[ks2][depth][3]<>posmov^[succ(num)][3]) or
         (killer[ks2][depth][4]<>posmov^[succ(num)][4]) then
        begin
          killer[ks][depth]:=posmov^[succ(num)];
          ks2:=ks;
          ks:=1-ks;
        end;
    end;
  if value=-2000000000 then
    begin
      if player then
        begin
          if check(brd,'k') then
            begin
              compmove:=-1000000000+depth;
              dispose(posmov);
              dispose(temp);
              exit;
            end;
          if scr<0 then
            compmove:=1900000000
          else
            compmove:=-1900000000;
          dispose(posmov);
          dispose(temp);
          exit;
        end
      else
        begin
          if check(brd,'K') then
            begin
              compmove:=-1000000000+depth;
              dispose(posmov);
              dispose(temp);
              exit;
            end;
          if scr>0 then
            compmove:=1900000000
          else
            compmove:=-1900000000;
          dispose(posmov);
          dispose(temp);
          exit;
        end;
    end;
  compmove:=a;
  dispose(posmov);
  dispose(temp);
end;

function startcomp(brd:Pboard;posmov:Pmoves;player:boolean;cas:Tcastle;var bmsf:Tmove;num:longint):boolean;
var
  value,a,depth:longint;
  mtu:Tmove;
  temp:Pboard;
  tcas:Tcastle;
begin
  depth:=0;
  new(temp);
  a:=-2000000000;
  while (num>0) do
    begin
      checktimer;
      if hour*360000+min*6000+sec*100+hsec>fmaxtime then
        begin
          startcomp:=false;
          dispose(temp);
          exit;
        end;
      temp^:=brd^;
      tcas:=cas;
      go(temp,posmov^[num],tcas);
      value:=-compmove(temp,succ(depth),not player,-2000000000,-a,tcas);
      if (value>a) then
        begin
          a:=value;
          mtu:=posmov^[num];
          bv:=value;
        end;
      dec(num);
    end;
   if a>900000000 then
     begin
       gotoxy(1,16);
       if player then write('white is')
       else write('black is');
       writeln(' checkmated in ',1000000000-a);
       maxlevels:=1000000000-a-1;
       delay(700);
     end;
   dispose(temp);
   bmsf:=mtu;
   startcomp:=true;
end;

function eval(brd:Pboard;player:boolean;cas:Tcastle):longint;
type
  Tcoord=record
    x,y:longint;
  end;
var
  a,b,c,v,rct,rcf,qct,qcf,hct,hcf:longint;
  kt,kf:Tcoord;
  rt,rf,qt,qf,ht,hf:array[1..9] of Tcoord;
  tpawn,fpawn,trook,frook,ofile:boolean;
begin
  v:=0;
  rct:=0;
  rcf:=0;
  qct:=0;
  qcf:=0;
  hct:=0;
  hcf:=0;
  if player then
    begin
      for a:=1 to 8 do
        begin
          tpawn:=false;
          fpawn:=false;
          trook:=false;
          frook:=false;
          for b:=1 to 8 do
            begin
              case brd^[a,b] of
                'h':begin
                      inc(hct);
                      ht[hct].x:=a;
                      ht[hct].y:=b;
                      if b<7 then inc(v,3000)
                      else inc(v,w[1,1]);
                      if a<=4 then
                        begin
                          if b<=4 then
                            inc(v,60-30*(8-a-b))
                          else
                            inc(v,60-30*(b-a-1));
                        end
                      else
                        begin
                          if b<=4 then
                            inc(v,60-30*(a-b-1))
                          else
                            inc(v,60-30*(a+b-10))
                        end;
                    end;
                'b':begin
                      if b<7 then inc(v,3000)
                      else inc(v,w[1,2]);
                    end;
                'r':begin
                      inc(rct);
                      rt[rct].x:=a;
                      rt[rct].y:=b;
                      if b=2 then inc(v,200);
                      if trook then
                        inc(v,5150)
                      else
                        begin
                          inc(v,5000);
                          trook:=true;
                        end;
                      ofile:=true;
                      for c:=2 to 7 do
                        if brd^[a,c] in ['p'] then
                          begin
                            ofile:=false;
                            break;
                          end;
                      if ofile then
                        begin
                          inc(v,30);
                          ofile:=true;
                          for c:=2 to 7 do
                            if brd^[a,c] in ['P'] then
                              begin
                                ofile:=false;
                                break;
                              end;
                          if ofile then
                            inc(v,70);
                        end;
                    end;
                'p':begin
                      if tpawn then
                        inc(v,930)
                      else
                        begin
                          if (b<7) then
                            begin
                              if (a>1) and (a<8) then
                                begin
                                  if (brd^[a-1,b+1]='e') and (brd^[a+1,b+1]='e') then
                                    dec(v,20);
                                end
                              else
                                begin
                                  if a=1 then
                                    begin
                                      if (brd^[a+1,b+1]='e') then
                                        dec(v,20);
                                    end
                                  else
                                    if (brd^[a-1,b+1]='e') then
                                      dec(v,20);
                                end;
                            end;
                          inc(v,1000);
                          tpawn:=true;
                        end;
                    end;
                'q':begin
                      inc(qct);
                      qt[qct].x:=a;
                      qt[qct].y:=b;
                      if b<7 then inc(v,9000)
                      else inc(v,w[1,5]);
                    end;
                'k':begin
                      kt.x:=a;
                      kt.y:=b;
                      if (not cas.castledt) then
                        begin
                          if not (cas.cqst) and not (cas.ckst) then
                            dec(v,150)
                          else if not (cas.cqst) then dec(v,80)
                          else if not (cas.ckst) then dec(v,120);
                        end;
                    end;
                'H':begin
                      inc(hcf);
                      hf[hcf].x:=a;
                      hf[hcf].y:=b;
                      if b>2 then dec(v,3000)
                      else dec(v,w[1,1]);
                      if a<=4 then
                        begin
                          if b<=4 then
                            dec(v,60-30*(8-a-b))
                          else
                            dec(v,60-30*(b-a-1));
                        end
                      else
                        begin
                          if b<=4 then
                            dec(v,60-30*(a-b-1))
                          else
                            dec(v,60-30*(a+b-10))
                        end;
                    end;
                'B':begin
                      if b>2 then dec(v,3000)
                      else dec(v,w[1,2]);
                    end;
                'R':begin
                      inc(rcf);
                      rf[rcf].x:=a;
                      rf[rcf].y:=b;
                      if b=7 then dec(v,200);
                      if frook then
                        dec(v,5150)
                      else
                        begin
                          dec(v,5000);
                          frook:=true;
                        end;
                      ofile:=true;
                      for c:=2 to 7 do
                        if brd^[a,c] in ['P'] then
                          begin
                            ofile:=false;
                            break;
                          end;
                      if ofile then
                        begin
                          dec(v,30);
                          ofile:=true;
                          for c:=2 to 7 do
                            if brd^[a,c] in ['p'] then
                              begin
                                ofile:=false;
                                break;
                              end;
                          if ofile then
                            dec(v,70);
                        end;
                    end;
                'P':begin
                      if fpawn then
                        dec(v,930)
                      else
                        begin
                          if b>2 then
                            begin
                              if (a>1) and (a<8) then
                                begin
                                  if (brd^[a-1,b-1]='e') and (brd^[a+1,b-1]='e') then
                                    inc(v,20);
                                end
                              else
                                begin
                                  if a=1 then
                                    begin
                                      if (brd^[a+1,b-1]='e') then
                                        inc(v,20);
                                    end
                                  else
                                    if (brd^[a-1,b-1]='e') then
                                      inc(v,20);
                                end;
                            end;
                          dec(v,1000);
                          fpawn:=true;
                        end;
                    end;
                'Q':begin
                      inc(qcf);
                      qf[qcf].x:=a;
                      qf[qcf].y:=b;
                      if b>2 then dec(v,9000)
                      else dec(v,w[1,5]);
                    end;
                'K':begin
                      kf.x:=a;
                      kf.y:=b;
                      if (not cas.castledf) then
                        begin
                          if not (cas.cqsf) and not (cas.cksf) then
                            inc(v,150)
                          else if not (cas.cqsf) then inc(v,80)
                          else if not (cas.cksf) then inc(v,120);
                        end;
                    end;
              end;
            end;
          end;
      for a:=1 to rct do
        begin
          b:=abs(rt[a].x-kf.x);
          c:=abs(rt[a].y-kf.y);
          if b<c then
            inc(v,10*(7-b))
          else inc(v,10*(7-c));
        end;
      for a:=1 to rcf do
        begin
          b:=abs(rf[a].x-kt.x);
          c:=abs(rf[a].y-kt.y);
          if b<c then
            dec(v,10*(7-b))
          else dec(v,10*(7-c));
        end;
      for a:=1 to hct do
        inc(v,5*(14-abs(ht[a].x-kf.x)-abs(ht[a].y-kf.y)));
      for a:=1 to hcf do
        dec(v,5*(14-abs(hf[a].x-kt.x)-abs(hf[a].y-kt.y)));
    end
  else
    begin
      for a:=1 to 8 do
        begin
          tpawn:=false;
          fpawn:=false;
          trook:=false;
          frook:=false;
          for b:=1 to 8 do
            begin
              case brd^[a,b] of
                'H':begin
                      inc(hcf);
                      hf[hcf].x:=a;
                      hf[hcf].y:=b;
                      if b>2 then inc(v,3000)
                      else inc(v,w[1,1]);
                      if a<=4 then
                        begin
                          if b<=4 then
                            inc(v,60-30*(8-a-b))
                          else
                            inc(v,60-30*(b-a-1));
                        end
                      else
                        begin
                          if b<=4 then
                            inc(v,60-30*(a-b-1))
                          else
                            inc(v,60-30*(a+b-10))
                        end;
                    end;
                'B':begin
                      if b>2 then inc(v,3000)
                      else inc(v,w[1,2]);
                    end;
                'R':begin
                      inc(rcf);
                      rf[rcf].x:=a;
                      rf[rcf].y:=b;
                      if b=7 then inc(v,200);
                      if frook then
                        inc(v,5150)
                      else
                        begin
                          inc(v,5000);
                          frook:=true;
                        end;
                      ofile:=true;
                      for c:=2 to 7 do
                        if brd^[a,c] in ['P'] then
                          begin
                            ofile:=false;
                            break;
                          end;
                      if ofile then
                        begin
                          inc(v,30);
                          ofile:=true;
                          for c:=2 to 7 do
                            if brd^[a,c] in ['p'] then
                              begin
                                ofile:=false;
                                break;
                              end;
                          if ofile then
                            inc(v,70);
                        end;
                    end;
                'P':begin
                      if fpawn then
                        inc(v,930)
                      else
                        begin
                          if b>2 then
                            begin
                              if (a>1) and (a<8) then
                                begin
                                  if (brd^[a-1,b-1]='e') and (brd^[a+1,b-1]='e') then
                                    dec(v,20);
                                end
                              else
                                begin
                                  if a=1 then
                                    begin
                                      if (brd^[a+1,b-1]='e') then
                                        dec(v,20);
                                    end
                                  else
                                    if (brd^[a-1,b-1]='e') then
                                      dec(v,20);
                                end;
                            end;
                          inc(v,1000);
                          fpawn:=true;
                        end;
                    end;
                'Q':begin
                      inc(qcf);
                      qf[qcf].x:=a;
                      qf[qcf].y:=b;
                      if b>2 then inc(v,9000)
                      else inc(v,w[1,5]);
                    end;
                'K':begin
                      kf.x:=a;
                      kf.y:=b;
                      if (not cas.castledf) then
                        begin
                          if not (cas.cqsf) and not (cas.cksf) then
                            dec(v,150)
                          else if not (cas.cqsf) then dec(v,80)
                          else if not (cas.cksf) then dec(v,120);
                        end;
                    end;
                'h':begin
                      inc(hct);
                      ht[hct].x:=a;
                      ht[hct].y:=b;
                      if b<7 then dec(v,3000)
                      else dec(v,w[1,1]);
                      if a<=4 then
                        begin
                          if b<=4 then
                            dec(v,60-30*(8-a-b))
                          else
                            dec(v,60-30*(b-a-1));
                        end
                      else
                        begin
                          if b<=4 then
                            dec(v,60-30*(a-b-1))
                          else
                            dec(v,60-30*(a+b-10))
                        end;
                    end;
                'b':begin
                      if b<7 then dec(v,3000)
                      else dec(v,w[1,2]);
                    end;
                'r':begin
                      inc(rct);
                      rt[rct].x:=a;
                      rt[rct].y:=b;
                      if b=2 then dec(v,200);
                      if trook then
                        dec(v,5150)
                      else
                        begin
                          dec(v,5000);
                          trook:=true;
                        end;
                      ofile:=true;
                      for c:=2 to 7 do
                        if brd^[a,c] in ['p'] then
                          begin
                            ofile:=false;
                            break;
                          end;
                      if ofile then
                        begin
                          dec(v,30);
                          ofile:=true;
                          for c:=2 to 7 do
                            if brd^[a,c] in ['P'] then
                              begin
                                ofile:=false;
                                break;
                              end;
                          if ofile then
                            dec(v,70);
                        end;
                    end;
                'p':begin
                      if tpawn then
                        dec(v,930)
                      else
                        begin
                          if b<7 then
                            begin
                              if (a>1) and (a<8) then
                                begin
                                  if (brd^[a-1,b+1]='e') and (brd^[a+1,b+1]='e') then
                                    inc(v,20);
                                end
                              else
                                begin
                                  if a=1 then
                                    begin
                                      if (brd^[a+1,b+1]='e') then
                                        inc(v,20);
                                    end
                                  else
                                    if (brd^[a-1,b+1]='e') then
                                      inc(v,20);
                                end;
                            end;
                          dec(v,1000);
                          tpawn:=true;
                        end;
                    end;
                'q':begin
                      inc(qct);
                      qt[qct].x:=a;
                      qt[qct].y:=b;
                      if b<7 then dec(v,9000)
                      else dec(v,w[1,5]);
                    end;
                'k':begin
                      kt.x:=a;
                      kt.y:=a;
                      if (not cas.castledt) then
                        begin
                          if not (cas.cqst) and not (cas.ckst) then
                            inc(v,150)
                          else if not (cas.cqst) then inc(v,80)
                          else if not (cas.ckst) then inc(v,120);
                        end;
                    end;
              end;
            end;
          end;
      for a:=1 to rct do
        begin
          b:=abs(rt[a].x-kf.x);
          c:=abs(rt[a].y-kf.y);
          if b<c then
            dec(v,10*(7-b))
          else dec(v,10*(7-c));
        end;
      for a:=1 to rcf do
        begin
          b:=abs(rf[a].x-kt.x);
          c:=abs(rf[a].y-kt.y);
          if b<c then
            inc(v,10*(7-b))
          else inc(v,10*(7-c));
        end;
      for a:=1 to hct do
        dec(v,5*(14-abs(ht[a].x-kf.x)-abs(ht[a].y-kf.y)));
      for a:=1 to hcf do
        inc(v,5*(14-abs(hf[a].x-kt.x)-abs(hf[a].y-kt.y)));
    end;
  eval:=v;
end;


function q2(brd:Pboard;depth:longint;player:boolean;a,b:longint;cas:Tcastle):longint;
var
  num,value,h:longint;
  k:char;
  posmov:Pmoves;
  temp:Pboard;
  tcas:Tcastle;
begin
  inc(qne);
  new(posmov);
  gencap(brd,posmov,num,player);
  value:=-2000000000;
  if player then k:='k'
  else k:='K';
  new(temp);
  while (num>0) and (value<b) do
    begin
      temp^:=brd^;
      tcas:=cas;
      go(temp,posmov^[num],tcas);
      if not check(temp,k) then
        begin
          value:=-q2(temp,succ(depth),not player,-b,-a,tcas);
          if (value>a) then a:=value;
        end;
      dec(num);
    end;
  if value=-2000000000 then
    begin
      q2:=eval2(brd,player,cas);
      if depth>hd then hd:=depth;
      dispose(temp);
      dispose(posmov);
      exit;
    end;
  h:=eval2(brd,player,cas);
  if a>h then
    q2:=a
  else q2:=h;
  dispose(posmov);
  dispose(temp);
end;

function compmove2(brd:Pboard;depth:longint;player:boolean;a,b:longint;cas:Tcastle):longint;
var
  num,value:longint;
  k:char;
  posmov:Pmoves;
  temp:Pboard;
  tcas:Tcastle;
begin
  if depth=levels then
    begin
      if wascap then compmove2:=q2(brd,depth,player,a,b,cas)
      else
        begin
          compmove2:=eval2(brd,player,cas);
          inc(ne);
        end;
      exit;
    end;
  inc(ne);
  new(posmov);
  movegen(brd,posmov,num,player,cas);
  for value:=num downto 1 do
    if (killer[ks][depth][1]=posmov^[value][1]) and
       (killer[ks][depth][2]=posmov^[value][2]) and
       (killer[ks][depth][3]=posmov^[value][3]) and
       (killer[ks][depth][4]=posmov^[value][4]) then
      begin
        move(posmov^[succ(value)],posmov^[value],(num-value)*sizeof(Tmove));
        posmov^[num]:=killer[ks][depth];
        break;
      end;
  for value:=num downto 1 do
    if (killer[ks2][depth][1]=posmov^[value][1]) and
       (killer[ks2][depth][2]=posmov^[value][2]) and
       (killer[ks2][depth][3]=posmov^[value][3]) and
       (killer[ks2][depth][4]=posmov^[value][4]) then
      begin
        move(posmov^[succ(value)],posmov^[value],(num-value)*sizeof(Tmove));
        posmov^[num]:=killer[ks2][depth];
        break;
      end;
  value:=-2000000000;
  if player then k:='k'
  else k:='K';
  new(temp);
  while (num>0) and (value<b) do
    begin
      temp^:=brd^;
      tcas:=cas;
      go(temp,posmov^[num],tcas);
      if not check(temp,k) then
        begin
          value:=-compmove2(temp,succ(depth),not player,-b,-a,tcas);
          if (value>a) then a:=value;
        end;
      dec(num);
    end;
  if value>=b then
    begin
      if (killer[ks2][depth][1]<>posmov^[succ(num)][1]) or
         (killer[ks2][depth][2]<>posmov^[succ(num)][2]) or
         (killer[ks2][depth][3]<>posmov^[succ(num)][3]) or
         (killer[ks2][depth][4]<>posmov^[succ(num)][4]) then
        begin
          killer[ks][depth]:=posmov^[succ(num)];
          ks2:=ks;
          ks:=1-ks;
        end;
    end;
  if value=-2000000000 then
    begin
      if player then
        begin
          if check(brd,'k') then
            begin
              compmove2:=-1000000000+depth;
              dispose(posmov);
              dispose(temp);
              exit;
            end;
          if scr<0 then
            compmove2:=1900000000
          else
            compmove2:=-1900000000;
          dispose(posmov);
          dispose(temp);
          exit;
        end
      else
        begin
          if check(brd,'K') then
            begin
              compmove2:=-1000000000+depth;
              dispose(posmov);
              dispose(temp);
              exit;
            end;
          if scr>0 then
            compmove2:=1900000000
          else
            compmove2:=-1900000000;
          dispose(posmov);
          dispose(temp);
          exit;
        end;
    end;
  compmove2:=a;
  dispose(posmov);
  dispose(temp);
end;

function startcomp2(brd:Pboard;posmov:Pmoves;player:boolean;cas:Tcastle;var bmsf:Tmove;num:longint):boolean;
var
  value,a,depth:longint;
  mtu:Tmove;
  temp:Pboard;
  tcas:Tcastle;
begin
  depth:=0;
  new(temp);
  a:=-2000000000;
  while (num>0) do
    begin
      checktimer;
      if hour*360000+min*6000+sec*100+hsec>tmaxtime then
        begin
          startcomp2:=false;
          dispose(temp);
          exit;
        end;
      temp^:=brd^;
      tcas:=cas;
      go(temp,posmov^[num],tcas);
      value:=-compmove2(temp,succ(depth),not player,-2000000000,-a,tcas);
      if (value>a) then
        begin
          a:=value;
          mtu:=posmov^[num];
          bv:=value;
        end;
      dec(num);
    end;
   if a>900000000 then
     begin
       gotoxy(1,16);
       if player then write('white is')
       else write('black is');
       writeln(' checkmated in ',1000000000-a);
       maxlevels:=1000000000-a-1;
       delay(700);
     end;
   dispose(temp);
   bmsf:=mtu;
   startcomp2:=true;
end;

function eval2(brd:Pboard;player:boolean;cas:Tcastle):longint;
type
  Tcoord=record
    x,y:longint;
  end;
var
  a,b,c,v,rct,rcf,qct,qcf,hct,hcf:longint;
  kt,kf:Tcoord;
  rt,rf,qt,qf,ht,hf:array[1..9] of Tcoord;
  tpawn,fpawn,trook,frook,ofile:boolean;
begin
  v:=0;
  rct:=0;
  rcf:=0;
  qct:=0;
  qcf:=0;
  hct:=0;
  hcf:=0;
  if player then
    begin
      for a:=1 to 8 do
        begin
          tpawn:=false;
          fpawn:=false;
          trook:=false;
          frook:=false;
          for b:=1 to 8 do
            begin
              case brd^[a,b] of
                'h':begin
                      inc(hct);
                      ht[hct].x:=a;
                      ht[hct].y:=b;
                      if b<7 then inc(v,3000)
                      else inc(v,w[1,1]);
                      if a<=4 then
                        begin
                          if b<=4 then
                            inc(v,60-30*(8-a-b))
                          else
                            inc(v,60-30*(b-a-1));
                        end
                      else
                        begin
                          if b<=4 then
                            inc(v,60-30*(a-b-1))
                          else
                            inc(v,60-30*(a+b-10))
                        end;
                    end;
                'b':begin
                      if b<7 then inc(v,3000)
                      else inc(v,w[1,2]);
                    end;
                'r':begin
                      inc(rct);
                      rt[rct].x:=a;
                      rt[rct].y:=b;
                      if b=2 then inc(v,200);
                      if trook then
                        inc(v,5150)
                      else
                        begin
                          inc(v,5000);
                          trook:=true;
                        end;
                      ofile:=true;
                      for c:=2 to 7 do
                        if brd^[a,c] in ['p'] then
                          begin
                            ofile:=false;
                            break;
                          end;
                      if ofile then
                        begin
                          inc(v,30);
                          ofile:=true;
                          for c:=2 to 7 do
                            if brd^[a,c] in ['P'] then
                              begin
                                ofile:=false;
                                break;
                              end;
                          if ofile then
                            inc(v,70);
                        end;
                    end;
                'p':begin
                      if tpawn then
                        inc(v,930)
                      else
                        begin
                          if (b<7) then
                            begin
                              if (a>1) and (a<8) then
                                begin
                                  if (brd^[a-1,b+1]='e') and (brd^[a+1,b+1]='e') then
                                    dec(v,20);
                                end
                              else
                                begin
                                  if a=1 then
                                    begin
                                      if (brd^[a+1,b+1]='e') then
                                        dec(v,20);
                                    end
                                  else
                                    if (brd^[a-1,b+1]='e') then
                                      dec(v,20);
                                end;
                            end;
                          inc(v,1000);
                          tpawn:=true;
                        end;
                    end;
                'q':begin
                      inc(qct);
                      qt[qct].x:=a;
                      qt[qct].y:=b;
                      if b<7 then inc(v,9000)
                      else inc(v,w[1,5]);
                    end;
                'k':begin
                      kt.x:=a;
                      kt.y:=b;
                      if (not cas.castledt) then
                        begin
                          if not (cas.cqst) and not (cas.ckst) then
                            dec(v,150)
                          else if not (cas.cqst) then dec(v,80)
                          else if not (cas.ckst) then dec(v,120);
                        end;
                    end;
                'H':begin
                      inc(hcf);
                      hf[hcf].x:=a;
                      hf[hcf].y:=b;
                      if b>2 then dec(v,3000)
                      else dec(v,w[1,1]);
                      if a<=4 then
                        begin
                          if b<=4 then
                            dec(v,60-30*(8-a-b))
                          else
                            dec(v,60-30*(b-a-1));
                        end
                      else
                        begin
                          if b<=4 then
                            dec(v,60-30*(a-b-1))
                          else
                            dec(v,60-30*(a+b-10))
                        end;
                    end;
                'B':begin
                      if b>2 then dec(v,3000)
                      else dec(v,w[1,2]);
                    end;
                'R':begin
                      inc(rcf);
                      rf[rcf].x:=a;
                      rf[rcf].y:=b;
                      if b=7 then dec(v,200);
                      if frook then
                        dec(v,5150)
                      else
                        begin
                          dec(v,5000);
                          frook:=true;
                        end;
                      ofile:=true;
                      for c:=2 to 7 do
                        if brd^[a,c] in ['P'] then
                          begin
                            ofile:=false;
                            break;
                          end;
                      if ofile then
                        begin
                          dec(v,30);
                          ofile:=true;
                          for c:=2 to 7 do
                            if brd^[a,c] in ['p'] then
                              begin
                                ofile:=false;
                                break;
                              end;
                          if ofile then
                            dec(v,70);
                        end;
                    end;
                'P':begin
                      if fpawn then
                        dec(v,930)
                      else
                        begin
                          if b>2 then
                            begin
                              if (a>1) and (a<8) then
                                begin
                                  if (brd^[a-1,b-1]='e') and (brd^[a+1,b-1]='e') then
                                    inc(v,20);
                                end
                              else
                                begin
                                  if a=1 then
                                    begin
                                      if (brd^[a+1,b-1]='e') then
                                        inc(v,20);
                                    end
                                  else
                                    if (brd^[a-1,b-1]='e') then
                                      inc(v,20);
                                end;
                            end;
                          dec(v,1000);
                          fpawn:=true;
                        end;
                    end;
                'Q':begin
                      inc(qcf);
                      qf[qcf].x:=a;
                      qf[qcf].y:=b;
                      if b>2 then dec(v,9000)
                      else dec(v,w[1,5]);
                    end;
                'K':begin
                      kf.x:=a;
                      kf.y:=b;
                      if (not cas.castledf) then
                        begin
                          if not (cas.cqsf) and not (cas.cksf) then
                            inc(v,150)
                          else if not (cas.cqsf) then inc(v,80)
                          else if not (cas.cksf) then inc(v,120);
                        end;
                    end;
              end;
            end;
          end;
      for a:=1 to rct do
        begin
          b:=abs(rt[a].x-kf.x);
          c:=abs(rt[a].y-kf.y);
          if b<c then
            inc(v,10*(7-b))
          else inc(v,10*(7-c));
        end;
      for a:=1 to rcf do
        begin
          b:=abs(rf[a].x-kt.x);
          c:=abs(rf[a].y-kt.y);
          if b<c then
            dec(v,10*(7-b))
          else dec(v,10*(7-c));
        end;
      for a:=1 to hct do
        inc(v,5*(14-abs(ht[a].x-kf.x)-abs(ht[a].y-kf.y)));
      for a:=1 to hcf do
        dec(v,5*(14-abs(hf[a].x-kt.x)-abs(hf[a].y-kt.y)));
    end
  else
    begin
      for a:=1 to 8 do
        begin
          tpawn:=false;
          fpawn:=false;
          trook:=false;
          frook:=false;
          for b:=1 to 8 do
            begin
              case brd^[a,b] of
                'H':begin
                      inc(hcf);
                      hf[hcf].x:=a;
                      hf[hcf].y:=b;
                      if b>2 then inc(v,3000)
                      else inc(v,w[1,1]);
                      if a<=4 then
                        begin
                          if b<=4 then
                            inc(v,60-30*(8-a-b))
                          else
                            inc(v,60-30*(b-a-1));
                        end
                      else
                        begin
                          if b<=4 then
                            inc(v,60-30*(a-b-1))
                          else
                            inc(v,60-30*(a+b-10))
                        end;
                    end;
                'B':begin
                      if b>2 then inc(v,3000)
                      else inc(v,w[1,2]);
                    end;
                'R':begin
                      inc(rcf);
                      rf[rcf].x:=a;
                      rf[rcf].y:=b;
                      if b=7 then inc(v,200);
                      if frook then
                        inc(v,5150)
                      else
                        begin
                          inc(v,5000);
                          frook:=true;
                        end;
                      ofile:=true;
                      for c:=2 to 7 do
                        if brd^[a,c] in ['P'] then
                          begin
                            ofile:=false;
                            break;
                          end;
                      if ofile then
                        begin
                          inc(v,30);
                          ofile:=true;
                          for c:=2 to 7 do
                            if brd^[a,c] in ['p'] then
                              begin
                                ofile:=false;
                                break;
                              end;
                          if ofile then
                            inc(v,70);
                        end;
                    end;
                'P':begin
                      if fpawn then
                        inc(v,930)
                      else
                        begin
                          if b>2 then
                            begin
                              if (a>1) and (a<8) then
                                begin
                                  if (brd^[a-1,b-1]='e') and (brd^[a+1,b-1]='e') then
                                    dec(v,20);
                                end
                              else
                                begin
                                  if a=1 then
                                    begin
                                      if (brd^[a+1,b-1]='e') then
                                        dec(v,20);
                                    end
                                  else
                                    if (brd^[a-1,b-1]='e') then
                                      dec(v,20);
                                end;
                            end;
                          inc(v,1000);
                          fpawn:=true;
                        end;
                    end;
                'Q':begin
                      inc(qcf);
                      qf[qcf].x:=a;
                      qf[qcf].y:=b;
                      if b>2 then inc(v,9000)
                      else inc(v,w[1,5]);
                    end;
                'K':begin
                      kf.x:=a;
                      kf.y:=b;
                      if (not cas.castledf) then
                        begin
                          if not (cas.cqsf) and not (cas.cksf) then
                            dec(v,150)
                          else if not (cas.cqsf) then dec(v,80)
                          else if not (cas.cksf) then dec(v,120);
                        end;
                    end;
                'h':begin
                      inc(hct);
                      ht[hct].x:=a;
                      ht[hct].y:=b;
                      if b<7 then dec(v,3000)
                      else dec(v,w[1,1]);
                      if a<=4 then
                        begin
                          if b<=4 then
                            dec(v,60-30*(8-a-b))
                          else
                            dec(v,60-30*(b-a-1));
                        end
                      else
                        begin
                          if b<=4 then
                            dec(v,60-30*(a-b-1))
                          else
                            dec(v,60-30*(a+b-10))
                        end;
                    end;
                'b':begin
                      if b<7 then dec(v,3000)
                      else dec(v,w[1,2]);
                    end;
                'r':begin
                      inc(rct);
                      rt[rct].x:=a;
                      rt[rct].y:=b;
                      if b=2 then dec(v,200);
                      if trook then
                        dec(v,5150)
                      else
                        begin
                          dec(v,5000);
                          trook:=true;
                        end;
                      ofile:=true;
                      for c:=2 to 7 do
                        if brd^[a,c] in ['p'] then
                          begin
                            ofile:=false;
                            break;
                          end;
                      if ofile then
                        begin
                          dec(v,30);
                          ofile:=true;
                          for c:=2 to 7 do
                            if brd^[a,c] in ['P'] then
                              begin
                                ofile:=false;
                                break;
                              end;
                          if ofile then
                            dec(v,70);
                        end;
                    end;
                'p':begin
                      if tpawn then
                        dec(v,930)
                      else
                        begin
                          if b<7 then
                            begin
                              if (a>1) and (a<8) then
                                begin
                                  if (brd^[a-1,b+1]='e') and (brd^[a+1,b+1]='e') then
                                    inc(v,20);
                                end
                              else
                                begin
                                  if a=1 then
                                    begin
                                      if (brd^[a+1,b+1]='e') then
                                        inc(v,20);
                                    end
                                  else
                                    if (brd^[a-1,b+1]='e') then
                                      inc(v,20);
                                end;
                            end;
                          dec(v,1000);
                          tpawn:=true;
                        end;
                    end;
                'q':begin
                      inc(qct);
                      qt[qct].x:=a;
                      qt[qct].y:=b;
                      if b<7 then dec(v,9000)
                      else dec(v,w[1,5]);
                    end;
                'k':begin
                      kt.x:=a;
                      kt.y:=a;
                      if (not cas.castledt) then
                        begin
                          if not (cas.cqst) and not (cas.ckst) then
                            inc(v,150)
                          else if not (cas.cqst) then inc(v,80)
                          else if not (cas.ckst) then inc(v,120);
                        end;
                    end;
              end;
            end;
          end;
      for a:=1 to rct do
        begin
          b:=abs(rt[a].x-kf.x);
          c:=abs(rt[a].y-kf.y);
          if b<c then
            dec(v,10*(7-b))
          else dec(v,10*(7-c));
        end;
      for a:=1 to rcf do
        begin
          b:=abs(rf[a].x-kt.x);
          c:=abs(rf[a].y-kt.y);
          if b<c then
            inc(v,10*(7-b))
          else inc(v,10*(7-c));
        end;
      for a:=1 to hct do
        dec(v,5*(14-abs(ht[a].x-kf.x)-abs(ht[a].y-kf.y)));
      for a:=1 to hcf do
        inc(v,5*(14-abs(hf[a].x-kt.x)-abs(hf[a].y-kt.y)));
    end;
  eval2:=v;
end;

procedure movegen(brd:Pboard;var ma:Pmoves;var num:longint;player:boolean;cas:Tcastle);
type
  Tcap=record
    m:Tmove;
    sc:longint;
  end;
var
   i,j,cc,pv:longint;
   mv:Tmove;
   up,up2:set of char;
   cap:array[1..100] of Tcap;

procedure sort;
var
   i,j,gap:longint;
   temp:Tcap;
begin
     gap:=cc;
     repeat
           gap:=gap shr 1;
           for i:=1 to cc-gap do
               if cap[i].sc>cap[i+gap].sc then
                  begin
                       temp:=cap[i];
                       cap[i]:=cap[i+gap];
                       cap[i+gap]:=temp;
                       j:=i-gap;
                       while (j>0) and (cap[j+gap].sc<cap[j].sc) do
                             begin
                                  temp:=cap[j];
                                  cap[j]:=cap[j+gap];
                                  cap[j+gap]:=temp;
                                  dec(j,gap);
                             end;
                  end;
     until gap=1;
end;

procedure rook;
begin
  if i<8 then
    begin
      mv[4]:=j;
      mv[3]:=succ(i);
      while (mv[3]<=8) and (brd^[mv[3],j]='e') do
        begin
          inc(num);
          ma^[num]:=mv;
          inc(mv[3]);
        end;
      if (mv[3]<=8) and (brd^[mv[3],j] in up) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=pval(brd^[mv[3],j])-pv;
        end;
    end;
  if i>1 then
    begin
      mv[3]:=pred(i);
      mv[4]:=j;
      while (mv[3]>=1) and (brd^[mv[3],j]='e') do
        begin
          inc(num);
          ma^[num]:=mv;
          dec(mv[3]);
        end;
      if (mv[3]>=1) and (brd^[mv[3],j] in up) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=pval(brd^[mv[3],j])-pv;
        end;
    end;
  if j<8 then
    begin
      mv[3]:=i;
      mv[4]:=succ(j);
      while (mv[4]<=8) and (brd^[i,mv[4]]='e') do
        begin
          inc(num);
          ma^[num]:=mv;
          inc(mv[4]);
        end;
      if (mv[4]<=8) and (brd^[i,mv[4]] in up) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=pval(brd^[i,mv[4]])-pv;
        end;
    end;
  if j>1 then
    begin
      mv[3]:=i;
      mv[4]:=pred(j);
      while (mv[4]>=1) and (brd^[i,mv[4]]='e') do
        begin
          inc(num);
          ma^[num]:=mv;
          dec(mv[4]);
        end;
      if (mv[4]>=1) and (brd^[i,mv[4]] in up) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=pval(brd^[i,mv[4]])-pv;
        end;
    end;
end;

procedure bishop;
begin
  if (i<8) and (j<8) then
    begin
      mv[3]:=succ(i);
      mv[4]:=succ(j);
      while (mv[3]<=8) and (mv[4]<=8) and (brd^[mv[3],mv[4]]='e') do
        begin
          inc(num);
          ma^[num]:=mv;
          inc(mv[3]);
          inc(mv[4]);
        end;
      if (mv[3]<=8) and (mv[4]<=8) and (brd^[mv[3],mv[4]] in up) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=pval(brd^[mv[3],mv[4]])-pv;
        end;
    end;
  if (i>1) and (j>1) then
    begin
      mv[3]:=pred(i);
      mv[4]:=pred(j);
      while (mv[3]>=1) and (mv[4]>=1) and (brd^[mv[3],mv[4]]='e') do
        begin
          inc(num);
          ma^[num]:=mv;
          dec(mv[3]);
          dec(mv[4]);
        end;
      if (mv[3]>=1) and (mv[4]>=1) and (brd^[mv[3],mv[4]] in up) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=pval(brd^[mv[3],mv[4]])-pv;
        end;
    end;
  if (i<8) and (j>1) then
    begin
      mv[3]:=succ(i);
      mv[4]:=pred(j);
      while (mv[3]<=8) and (mv[4]>=1) and (brd^[mv[3],mv[4]]='e') do
        begin
          inc(num);
          ma^[num]:=mv;
          inc(mv[3]);
          dec(mv[4]);
        end;
      if (mv[3]<=8) and (mv[4]>=1) and (brd^[mv[3],mv[4]] in up) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=pval(brd^[mv[3],mv[4]])-pv;
        end;
    end;
  if (i>1) and (j<8) then
    begin
      mv[3]:=pred(i);
      mv[4]:=succ(j);
      while (mv[3]>=1) and (mv[4]<=8) and (brd^[mv[3],mv[4]]='e') do
        begin
          inc(num);
          ma^[num]:=mv;
          dec(mv[3]);
          inc(mv[4]);
        end;
      if (mv[3]>=1) and (mv[4]<=8) and (brd^[mv[3],mv[4]] in up) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=pval(brd^[mv[3],mv[4]])-pv;
        end;
    end;
end;

procedure horse;
begin
  if (i<7) then
    begin
      mv[3]:=i+2;
      if (j<8) then
        begin
          mv[4]:=succ(j);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-3000;
                end;
            end;
        end;
      if (j>1) then
        begin
          mv[4]:=pred(j);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-3000;
                end;
            end;
        end;
    end;
  if (i>2) then
    begin
      mv[3]:=i-2;
      if (j<8) then
        begin
          mv[4]:=succ(j);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-3000;
                end;

            end;
        end;
      if (j>1) then
        begin
          mv[4]:=pred(j);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-3000;
                end;
            end;
        end;
    end;
  if (j<7) then
    begin
      mv[4]:=j+2;
      if (i<8) then
        begin
          mv[3]:=succ(i);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-3000;
                end;
            end;
        end;
      if (i>1) then
        begin
          mv[3]:=pred(i);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-3000;
                end;
            end;
        end;
    end;
  if (j>2) then
    begin
      mv[4]:=j-2;
      if (i<8) then
        begin
          mv[3]:=succ(i);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-3000;
                end;
            end;
        end;
      if (i>1) then
        begin
          mv[3]:=pred(i);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-3000;
                end;
            end;
        end;
    end;
end;

procedure king;
begin
  if (i<8) then
    begin
      mv[3]:=succ(i);
      mv[4]:=j;
      if (brd^[mv[3],mv[4]] in (up2)) then
        begin
          if brd^[mv[3],mv[4]]='e' then
            begin
              inc(num);
              ma^[num]:=mv;
            end
          else
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=pval(brd^[mv[3],mv[4]])-50000;
            end;
        end;
      if j<8 then
        begin
          mv[4]:=succ(j);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-50000;
                end;
            end;
        end;
      if j>1 then
        begin
          mv[4]:=pred(j);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-50000;
                end;
            end;
        end;
    end;
  if i>1 then
    begin
      mv[3]:=pred(i);
      mv[4]:=j;
      if (brd^[mv[3],mv[4]] in (up2)) then
        begin
          if brd^[mv[3],mv[4]]='e' then
            begin
              inc(num);
              ma^[num]:=mv;
            end
          else
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=pval(brd^[mv[3],mv[4]])-50000;
            end;
        end;
      if j<8 then
        begin
          mv[4]:=succ(j);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-50000;
                end;
            end;
        end;
      if j>1 then
        begin
          mv[4]:=pred(j);
          if (brd^[mv[3],mv[4]] in (up2)) then
            begin
              if brd^[mv[3],mv[4]]='e' then
                begin
                  inc(num);
                  ma^[num]:=mv;
                end
              else
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=pval(brd^[mv[3],mv[4]])-50000;
                end;
            end;
        end;
    end;
  if j<8 then
    begin
      mv[3]:=i;
      mv[4]:=succ(j);
      if (brd^[mv[3],mv[4]] in (up2)) then
        begin
          if brd^[mv[3],mv[4]]='e' then
            begin
              inc(num);
              ma^[num]:=mv;
            end
          else
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=pval(brd^[mv[3],mv[4]])-50000;
            end;
        end;
    end;
  if j>1 then
    begin
      mv[3]:=i;
      mv[4]:=pred(j);
      if (brd^[mv[3],mv[4]] in (up2)) then
        begin
          if brd^[mv[3],mv[4]]='e' then
            begin
              inc(num);
              ma^[num]:=mv;
            end
          else
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=pval(brd^[mv[3],mv[4]])-50000;
            end;
        end;
    end;
end;

begin
  cc:=0;
  num:=0;
  if player then
    begin
      up:=wp;
      up2:=up+['e'];
      for i:=1 to 8 do
        begin
          mv[1]:=i;
          for j:=1 to 8 do
            begin
              mv[2]:=j;
              case brd^[i,j] of
                'p':begin
                      if (brd^[i,pred(j)]='e') then
                        begin
                          mv[3]:=i;
                          mv[4]:=pred(j);
                          inc(num);
                          ma^[num]:=mv;
                          dec(mv[4]);
                          if (j=7) and (brd^[i,mv[4]]='e') then
                               begin
                                 inc(num);
                                 ma^[num]:=mv;
                               end;
                        end;
                      mv[3]:=succ(i);
                      mv[4]:=pred(j);
                      {remember did not do en passant here yet}
                      if (i<8) and (brd^[succ(i),pred(j)] in wp) then
                        begin
                          inc(cc);
                          cap[cc].m:=mv;
                          cap[cc].sc:=pval(brd^[succ(i),pred(j)])-1000;
                        end;
                      mv[3]:=pred(i);
                      mv[4]:=pred(j);
                      if (i>1) and (brd^[pred(i),pred(j)] in wp) then
                        begin
                          inc(cc);
                          cap[cc].m:=mv;
                          cap[cc].sc:=pval(brd^[pred(i),pred(j)])-1000;
                        end;
                    end;
                'q':begin
                      pv:=9000;
                      rook;
                      bishop;
                    end;
                'h':horse;
                'b':begin
                      pv:=3000;
                      bishop;
                    end;
                'r':begin
                      pv:=5000;
                      rook;
                    end;
                'k':begin
                      king;
                      {castling code}
                      if (cas.ckst) and not check(brd,'k') and (brd^[6,8]='e') and (brd^[7,8]='e') then
                        begin
                          mv[1]:=5;
                          mv[2]:=8;
                          mv[3]:=6;
                          mv[4]:=8;
                          if removecheck(brd,'k',mv) then
                            begin
                              mv[3]:=7;
                              inc(num);
                              ma^[num]:=mv;
                            end;
                        end;
                        if (cas.cqst) and not check(brd,'k') and (brd^[4,8]='e') and (brd^[3,8]='e') then
                        begin
                          mv[1]:=5;
                          mv[2]:=8;
                          mv[3]:=4;
                          mv[4]:=8;
                          if removecheck(brd,'k',mv) then
                            begin
                              mv[3]:=3;
                              inc(num);
                              ma^[num]:=mv;
                            end;
                        end;

                    end;
              end;
            end;
        end;
    end
  else
    begin
      up:=bp;
      up2:=up+['e'];
      for i:=1 to 8 do
        begin
          mv[1]:=i;
          for j:=1 to 8 do
            begin
              mv[2]:=j;
              case brd^[i,j] of
                'P':begin
                      if (brd^[i,succ(j)]='e') then
                        begin
                          mv[3]:=i;
                          mv[4]:=succ(j);
                          inc(num);
                          ma^[num]:=mv;
                          inc(mv[4]);
                          if (j=2) and (brd^[i,mv[4]]='e') then
                               begin
                                 inc(num);
                                 ma^[num]:=mv;
                               end;
                        end;
                      mv[3]:=succ(i);
                      mv[4]:=succ(j);
                      {remember did not do en passant here yet}
                      if (i<8) and (brd^[succ(i),succ(j)] in bp) then
                        begin
                          inc(cc);
                          cap[cc].m:=mv;
                          cap[cc].sc:=pval(brd^[succ(i),succ(j)])-1000;
                        end;
                      mv[3]:=pred(i);
                      mv[4]:=succ(j);
                      if (i>1) and (brd^[pred(i),succ(j)] in bp) then
                        begin
                          inc(cc);
                          cap[cc].m:=mv;
                          cap[cc].sc:=pval(brd^[pred(i),pred(j)])-1000;
                        end;
                    end;
                'Q':begin
                      pv:=9000;
                      rook;
                      bishop;
                    end;
                'H':horse;
                'B':begin
                      pv:=3000;
                      bishop;
                    end;
                'R':begin
                      pv:=5000;
                      rook;
                    end;
                'K':begin
                      king;
                      {castling code}
                      if (cas.cksf) and not check(brd,'K') and (brd^[6,1]='e') and (brd^[7,1]='e') then
                        begin
                          mv[1]:=5;
                          mv[2]:=1;
                          mv[3]:=6;
                          mv[4]:=1;
                          if removecheck(brd,'K',mv) then
                            begin
                              mv[3]:=7;
                              inc(num);
                              ma^[num]:=mv;
                            end;
                        end;
                      if (cas.cqsf) and not check(brd,'K') and (brd^[4,1]='e') and (brd^[3,1]='e') then
                        begin
                          mv[1]:=5;
                          mv[2]:=1;
                          mv[3]:=4;
                          mv[4]:=1;
                          if removecheck(brd,'K',mv) then
                            begin
                              mv[3]:=3;
                              inc(num);
                              ma^[num]:=mv;
                            end;
                        end;
                    end;
              end;
            end;
        end;
  end;
  for i:=1 to num do
    begin
      j:=succ(random(num));
      mv:=ma^[i];
      ma^[i]:=ma^[j];
      ma^[j]:=mv;
    end;
  if cc>1 then sort;
  for i:=1 to cc do
    ma^[num+i]:=cap[i].m;
  inc(num,cc);
end;

procedure gencap(brd:Pboard;var ma:Pmoves;var cc:longint;player:boolean);
type
  Tcap=record
    m:Tmove;
    sc:longint;
  end;
var
   i,j,z,pv:longint;
   mv:Tmove;
   up:set of char;
   cap:array[1..100] of Tcap;

procedure sort;
var
   i,j,gap:longint;
   temp:Tcap;
begin
     gap:=cc;
     repeat
           gap:=gap shr 1;
           for i:=1 to cc-gap do
               if cap[i].sc>cap[i+gap].sc then
                  begin
                       temp:=cap[i];
                       cap[i]:=cap[i+gap];
                       cap[i+gap]:=temp;
                       j:=i-gap;
                       while (j>0) and (cap[j+gap].sc<cap[j].sc) do
                             begin
                                  temp:=cap[j];
                                  cap[j]:=cap[j+gap];
                                  cap[j+gap]:=temp;
                                  dec(j,gap);
                             end;
                  end;
     until gap=1;
end;

procedure rook;
begin
  if i<8 then
    begin
      mv[4]:=j;
      mv[3]:=succ(i);
      while (mv[3]<=8) and (brd^[mv[3],mv[4]]='e') do
        begin
          inc(mv[3]);
        end;
      if (mv[3]<=8) and (brd^[mv[3],mv[4]] in up) then
        begin
          z:=pval(brd^[mv[3],mv[4]])-pv;
          if z>=0 then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
  if i>1 then
    begin
      mv[3]:=pred(i);
      mv[4]:=j;
      while (mv[3]>=1) and (brd^[mv[3],mv[4]]='e') do
        begin
          dec(mv[3]);
        end;
      if (mv[3]>=1) and (brd^[mv[3],mv[4]] in up) then
        begin
          z:=pval(brd^[mv[3],mv[4]])-pv;
          if z>=0 then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
  if j<8 then
    begin
      mv[3]:=i;
      mv[4]:=succ(j);
      while (mv[4]<=8) and (brd^[mv[3],mv[4]]='e') do
        begin
          inc(mv[4]);
        end;
      if (mv[4]<=8) and (brd^[mv[3],mv[4]] in up) then
        begin
          z:=pval(brd^[mv[3],mv[4]])-pv;
          if z>=0 then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
  if j>1 then
    begin
      mv[3]:=i;
      mv[4]:=pred(j);
      while (mv[4]>=1) and (brd^[mv[3],mv[4]]='e') do
        begin
          dec(mv[4]);
        end;
      if (mv[4]>=1) and (brd^[mv[3],mv[4]] in up) then
        begin
          z:=pval(brd^[mv[3],mv[4]])-pv;
          if z>=0 then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
end;

procedure bishop;
begin
  if (i<8) and (j<8) then
    begin
      mv[3]:=succ(i);
      mv[4]:=succ(j);
      while (mv[3]<=8) and (mv[4]<=8) and (brd^[mv[3],mv[4]]='e') do
        begin
          inc(mv[3]);
          inc(mv[4]);
        end;
      if (mv[3]<=8) and (mv[4]<=8) and (brd^[mv[3],mv[4]] in up) then
        begin
          z:=pval(brd^[mv[3],mv[4]])-pv;
          if z>=0 then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
  if (i>1) and (j>1) then
    begin
      mv[3]:=pred(i);
      mv[4]:=pred(j);
      while (mv[3]>=1) and (mv[4]>=1) and (brd^[mv[3],mv[4]]='e') do
        begin
          dec(mv[3]);
          dec(mv[4]);
        end;
      if (mv[3]>=1) and (mv[4]>=1) and (brd^[mv[3],mv[4]] in up) then
        begin
          z:=pval(brd^[mv[3],mv[4]])-pv;
          if z>=0 then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
  if (i<8) and (j>1) then
    begin
      mv[3]:=succ(i);
      mv[4]:=pred(j);
      while (mv[3]<=8) and (mv[4]>=1) and (brd^[mv[3],mv[4]]='e') do
        begin
          inc(mv[3]);
          dec(mv[4]);
        end;
      if (mv[3]<=8) and (mv[4]>=1) and (brd^[mv[3],mv[4]] in up) then
        begin
          z:=pval(brd^[mv[3],mv[4]])-pv;
          if z>=0 then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
  if (i>1) and (j<8) then
    begin
      mv[3]:=pred(i);
      mv[4]:=succ(j);
      while (mv[3]>=1) and (mv[4]<=8) and (brd^[mv[3],mv[4]]='e') do
        begin
          dec(mv[3]);
          inc(mv[4]);
        end;
      if (mv[3]>=1) and (mv[4]<=8) and (brd^[mv[3],mv[4]] in up) then
        begin
          z:=pval(brd^[mv[3],mv[4]])-pv;
          if z>=0 then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
end;

procedure horse;
begin
  if (i<7) then
    begin
      mv[3]:=i+2;
      if (j<8) then
        begin
          mv[4]:=succ(j);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              z:=pval(brd^[mv[3],mv[4]])-pv;
              if z>=0 then
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=z;
                end;
            end;
        end;
      if (j>1) then
        begin
          mv[4]:=pred(j);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              z:=pval(brd^[mv[3],mv[4]])-3000;
              if z>=0 then
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=z;
                end;
            end;
        end;
    end;
  if (i>2) then
    begin
      mv[3]:=i-2;
      if (j<8) then
        begin
          mv[4]:=succ(j);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              z:=pval(brd^[mv[3],mv[4]])-pv;
              if z>=0 then
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=z;
                end;
            end;
        end;
      if (j>1) then
        begin
          mv[4]:=pred(j);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              z:=pval(brd^[mv[3],mv[4]])-pv;
              if z>=0 then
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=z;
                end;
            end;
        end;
    end;
  if (j<7) then
    begin
      mv[4]:=j+2;
      if (i<8) then
        begin
          mv[3]:=succ(i);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              z:=pval(brd^[mv[3],mv[4]])-pv;
              if z>=0 then
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=z;
                end;
            end;
        end;
      if (i>1) then
        begin
          mv[3]:=pred(i);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              z:=pval(brd^[mv[3],mv[4]])-pv;
              if z>=0 then
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=z;
                end;
            end;
        end;
    end;
  if (j>2) then
    begin
      mv[4]:=j-2;
      if (i<8) then
        begin
          mv[3]:=succ(i);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              z:=pval(brd^[mv[3],mv[4]])-pv;
              if z>=0 then
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=z;
                end;
            end;
        end;
      if (i>1) then
        begin
          mv[3]:=pred(i);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              z:=pval(brd^[mv[3],mv[4]])-pv;
              if z>=0 then
                begin
                  inc(cc);
                  cap[cc].m:=mv;
                  cap[cc].sc:=z;
                end;
            end;
        end;
    end;
end;

procedure king;
begin
  if (i<8) then
    begin
      mv[3]:=succ(i);
      mv[4]:=j;
      if (brd^[mv[3],mv[4]] in (up)) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=z;
        end;
      if j<8 then
        begin
          mv[4]:=succ(j);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
      if j>1 then
        begin
          mv[4]:=pred(j);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
  if i>1 then
    begin
      mv[3]:=pred(i);
      mv[4]:=j;
      if (brd^[mv[3],mv[4]] in (up)) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=z;
        end;
      if j<8 then
        begin
          mv[4]:=succ(j);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
      if j>1 then
        begin
          mv[4]:=pred(j);
          if (brd^[mv[3],mv[4]] in (up)) then
            begin
              inc(cc);
              cap[cc].m:=mv;
              cap[cc].sc:=z;
            end;
        end;
    end;
  if j<8 then
    begin
      mv[3]:=i;
      mv[4]:=succ(j);
      if (brd^[mv[3],mv[4]] in (up)) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=z;
        end;
    end;
  if j>1 then
    begin
      mv[3]:=i;
      mv[4]:=pred(j);
      if (brd^[mv[3],mv[4]] in (up)) then
        begin
          inc(cc);
          cap[cc].m:=mv;
          cap[cc].sc:=z;
        end;
    end;
end;

begin
  cc:=0;
  if player then
    begin
      up:=wp;
      for i:=1 to 8 do
        begin
          mv[1]:=i;
          for j:=1 to 8 do
            begin
              mv[2]:=j;
              case brd^[i,j] of
                'p':begin
                      pv:=pc;
                      mv[3]:=succ(i);
                      mv[4]:=pred(j);
                      {remember did not do en passant here yet}
                      if (i<8) and (brd^[succ(i),pred(j)] in wp) then
                        begin
                          inc(cc);
                          cap[cc].m:=mv;
                          cap[cc].sc:=pval(brd^[succ(i),pred(j)])-pv;
                        end;
                      mv[3]:=pred(i);
                      mv[4]:=pred(j);
                      if (i>1) and (brd^[pred(i),pred(j)] in wp) then
                        begin
                          inc(cc);
                          cap[cc].m:=mv;
                          cap[cc].sc:=pval(brd^[pred(i),pred(j)])-pv;
                        end;
                    end;
                'q':begin
                      pv:=qc;
                      rook;
                      bishop;
                    end;
                'h':begin
                      pv:=hc;
                      horse;
                    end;
                'b':begin
                      pv:=bc;
                      bishop;
                    end;
                'r':begin
                      pv:=rc;
                      rook;
                    end;
                'k':begin
                      king;
                    end;
              end;
            end;
        end;
    end
  else
    begin
      up:=bp;
      for i:=1 to 8 do
        begin
          mv[1]:=i;
          for j:=1 to 8 do
            begin
              mv[2]:=j;
              case brd^[i,j] of
                'P':begin
                      pv:=pc;
                      mv[3]:=succ(i);
                      mv[4]:=succ(j);
                      {remember did not do en passant here yet}
                      if (i<8) and (brd^[succ(i),succ(j)] in bp) then
                        begin
                          inc(cc);
                          cap[cc].m:=mv;
                          cap[cc].sc:=pval(brd^[succ(i),succ(j)])-pv;
                        end;
                      mv[3]:=pred(i);
                      mv[4]:=succ(j);
                      if (i>1) and (brd^[pred(i),succ(j)] in bp) then
                        begin
                          inc(cc);
                          cap[cc].m:=mv;
                          cap[cc].sc:=pval(brd^[pred(i),pred(j)])-pv;
                        end;
                    end;
                'Q':begin
                      pv:=qc;
                      rook;
                      bishop;
                    end;
                'H':begin
                      pv:=hc;
                      horse;
                    end;
                'B':begin
                      pv:=bc;
                      bishop;
                    end;
                'R':begin
                      pv:=rc;
                      rook;
                    end;
                'K':begin
                      king;
                    end;
              end;
            end;
        end;
  end;
  if cc>1 then sort;
  for i:=1 to cc do
    ma^[i]:=cap[i].m;
end;

procedure im;
begin
  textattr:=4;
  gotoxy(1,17);
  textattr:=15;
  write('illegal move');
  delay(500);
  clrscr;
  drawboard(board);
end;

procedure humancomp;
label
  redo;
begin
  repeat
    enp[1]:=126;
    for i:=1 to 8 do
      for j:=1 to 8 do
        green[i,j]:=false;
    scr:=eval2(board,true,castle);
    clrscr;
    drawboard(board);
    if turn then
      wtime:=wtime+hour*360000+min*6000+sec*100+hsec
    else
      btime:=btime+hour*360000+min*6000+sec*100+hsec;
    gotoxy(50,5);
    write('White''s Time: ');
    if wtime div 360000<10 then write('0');
    write(wtime div 360000,':');
    if (wtime mod 360000) div 6000<10 then write('0');
    write((wtime mod 360000) div 6000,':');
    if ((wtime mod 360000) mod 6000) div 100<10 then write('0');
    write(((wtime mod 360000) mod 6000) div 100,'.');
    if ((wtime mod 360000) mod 6000) mod 100<10 then write('0');
    write(((wtime mod 360000) mod 6000) mod 100);
    gotoxy(50,6);
    write('Black''s Time: ');
    if btime div 360000<10 then write('0');
    write(btime div 360000,':');
    if (btime mod 360000) div 6000<10 then write('0');
    write((btime mod 360000) div 6000,':');
    if ((btime mod 360000) mod 6000) div 100<10 then write('0');
    write(((btime mod 360000) mod 6000) div 100,'.');
    if ((btime mod 360000) mod 6000) mod 100<10 then write('0');
    write(((btime mod 360000) mod 6000) mod 100);
    gotoxy(50,8);
    writeln('MOVES: ',pred(mc));
    gotoxy(50,10);
    writeln('SCORE: ',scr);
    if not turn then
      begin
        gotoxy(1,10);
        if mc>1 then
          begin
            write('moved in ');
            if hour<10 then
              write('0');
            write(hour,':');
            if min<10 then
              write('0');
            write(min,':');
            if sec<10 then
              write('0');
            write(sec,'.');
            if hsec<10 then
              write('0');
            writeln(hsec);
            writeln('evaluated ',ne,' + ',qne,' = ',ne+qne,' nodes');
            writeln('running at ',round((ne)/(0.00001+hour*3600+min*60+sec+hsec/100)),' nps');
            writeln('its move was ',chr(moves^[pred(mc)][1]+ord('a')-1),moves^[pred(mc)][2]
                                   ,'-',chr(moves^[pred(mc)][3]+ord('a')-1),moves^[pred(mc)][4]);
            writeln('predicted score in ',lgot,' moves is ',bv);
            writeln('Highest Depth: ',hd);
          end;
        if check(board,'K') then
          begin
            if mate(board,'K') then
              begin
                clrscr;
                drawboard(board);
                gotoxy(1,16);
                writeln('checkmate');
                readkey;
                done;
              end
            else
              begin
                gotoxy(1,18);
                writeln('check');
              end;
          end;

        lg:=false;
        while not lg do
          begin
            starttimer;           
           redo:
            gotoxy(1,16);
            readln(inp);
            if inp='q' then done;
            if (length(inp)=2) then
              begin
                cmove[1]:=ord(upcase(inp[1]))-64;
                cmove[2]:=ord(inp[2])-48;
                if check(board,'K') then
                  begin
                    castletmp:=castle;
                    castle.cksf:=false;
                    castle.cqsf:=false;
                    for i:=1 to 8 do
                      for j:=1 to 8 do
                        begin
                          cmove[3]:=i;
                          cmove[4]:=j;
                          if (legal(board,cmove,false)) and (removecheck(board,'K',cmove)) then
                            begin
                              green[cmove[3],cmove[4]]:=true;
                              lg:=true;
                            end;
                        end;
                      castle:=castletmp;
                  end
                else
                  for i:=1 to 8 do
                    for j:=1 to 8 do
                      begin
                        cmove[3]:=i;
                        cmove[4]:=j;
                        if (legal(board,cmove,false)) and (removecheck(board,'K',cmove)) then
                          begin
                            green[cmove[3],cmove[4]]:=true;
                            lg:=true;
                          end;
                      end;
                if not lg then im;
              end;
          end;
        clrscr;
        drawboard(board);
        lg:=false;
        while not lg do
          begin
            gotoxy(1,16);
            readln(inp);
            if inp='q' then done
            else if inp='b' then
              begin
                for i:=1 to 8 do
                  for j:=1 to 8 do
                    green[i,j]:=false;
                clrscr;
                drawboard(board);
                goto redo;
              end;
            cmove[3]:=ord(upcase(inp[1]))-64;
            cmove[4]:=ord(inp[2])-48;
            if check(board,'K') then
              begin
                castletmp:=castle;
                castle.cksf:=false;
                castle.cqsf:=false;
                if (legal(board,cmove,false)) and (removecheck(board,'K',cmove)) then
                  lg:=true;
                castle:=castletmp;
              end
            else
              if removecheck(board,'K',cmove) and (legal(board,cmove,false)) then
                lg:=true;
            if not lg then im;
          end;
        checktimer;
      end
    else
      begin
        write('you moved in ');
        if hour<10 then
          write('0');
        write(hour,':');
        if min<10 then
          write('0');
        write(min,':');
        if sec<10 then
          write('0');
        write(sec,'.');
        if hsec<10 then
          write('0');
        writeln(hsec);
        writeln('your move was ',chr(moves^[pred(mc)][1]+ord('a')-1),moves^[pred(mc)][2]
                                ,'-',chr(moves^[pred(mc)][3]+ord('a')-1),moves^[pred(mc)][4]);
        if check(board,'k') then
          begin
            if mate(board,'k') then
              begin
                clrscr;
                drawboard(board);
                gotoxy(1,16);
                writeln('checkmate');
                readkey;
                done;
              end
            else
              begin
                gotoxy(1,18);
                writeln('check');
              end;
          end;
        ne:=0;
        qne:=0;
        hd:=0;
        id(board,true,castle);
        checktimer;  
        if legal(board,bm,true) then cmove:=bm
        else
          begin
            writeln('OOPS');
            done;
          end;
        move(killer[0][3],killer[0][1],(maxkillers-2)*sizeof(Tmove));
        move(killer[1][3],killer[1][1],(maxkillers-2)*sizeof(Tmove));
      end;
    moves^[mc]:=cmove;
    go(board,cmove,castle);
    turn:=not turn;
    inc(mc);
  until false;
  done;
end;
 
procedure compcomp;
begin
  repeat
    enp[1]:=126;
    scr:=eval2(board,true,castle);
    clrscr;
    drawboard(board);
    if turn then
      wtime:=wtime+hour*360000+min*6000+sec*100+hsec
    else
      btime:=btime+hour*360000+min*6000+sec*100+hsec;
    gotoxy(50,5);
    write('White''s Time: ');
    if wtime div 360000<10 then write('0');
    write(wtime div 360000,':');
    if (wtime mod 360000) div 6000<10 then write('0');
    write((wtime mod 360000) div 6000,':');
    if ((wtime mod 360000) mod 6000) div 100<10 then write('0');
    write(((wtime mod 360000) mod 6000) div 100,'.');
    if ((wtime mod 360000) mod 6000) mod 100<10 then write('0');
    write(((wtime mod 360000) mod 6000) mod 100);
    gotoxy(50,6);
    write('Black''s Time: ');
    if btime div 360000<10 then write('0');
    write(btime div 360000,':');
    if (btime mod 360000) div 6000<10 then write('0');
    write((btime mod 360000) div 6000,':');
    if ((btime mod 360000) mod 6000) div 100<10 then write('0');
    write(((btime mod 360000) mod 6000) div 100,'.');
    if ((btime mod 360000) mod 6000) mod 100<10 then write('0');
    write(((btime mod 360000) mod 6000) mod 100);
    gotoxy(50,8);
    writeln('MOVES: ',pred(mc));
    gotoxy(50,10);
    writeln('SCORE: ',scr);
    if (mc>1) then
      begin
        gotoxy(1,10);
        if turn then write('white')
        else write('black');
        write(' moved in ');
        if hour<10 then
          write('0');
        write(hour,':');
        if min<10 then
          write('0');
        write(min,':');
        if sec<10 then
          write('0');
        write(sec,'.');
        if hsec<10 then
          write('0');
        writeln(hsec);
        writeln('evaluated ',ne,' + ',qne,' = ',ne+qne,' nodes');
        writeln('running at ',round((ne)/(0.00001+hour*3600+min*60+sec+hsec/100)),' nps');
        writeln('its move was ',chr(moves^[pred(mc)][1]+ord('a')-1),moves^[pred(mc)][2],'-',chr(moves^[pred(mc)][3]+ord('a')-1)
                               ,moves^[pred(mc)][4]);
        writeln('Highest Depth: ',hd);
      end;
    if check(board,'K') then
      begin
        if mate(board,'K') then
          begin
            clrscr;
            drawboard(board);
            gotoxy(1,15);
            writeln('checkmate');
            readkey;
            done;
          end
        else
          begin
            gotoxy(1,15);
            writeln('check');
          end;
      end
    else if check(board,'k') then
      begin
        if mate(board,'k') then
          begin
            clrscr;
            drawboard(board);
            gotoxy(1,15);
            writeln('checkmate');
            readkey;
            done;
          end
        else
          begin
            gotoxy(1,15);
            writeln('check');
          end;
      end;
    if not turn then
      begin
        ne:=0;
        qne:=0;
        hd:=0;
        starttimer;
        id(board,false,castle);
        checktimer;
        if legal(board,bm,false) then cmove:=bm
        else
          begin
            writeln('OOPS');
            writeln(bm[1],bm[2],bm[3],bm[4]);
            done;
          end;
        move(killer[0][2],killer[0][1],pred(maxkillers)*sizeof(Tmove));
        move(killer[1][2],killer[1][1],pred(maxkillers)*sizeof(Tmove));
      end
    else
      begin
        ne:=0;
        qne:=0;
        hd:=0;
        id(board,true,castle);
        checktimer;
        if legal(board,bm,true) then cmove:=bm
        else
          begin
            writeln('OOPS');
            writeln(bm[1],bm[2],bm[3],bm[4]);
            done;
          end;
        move(killer[0][2],killer[0][1],pred(maxkillers)*sizeof(Tmove));
        move(killer[1][2],killer[1][1],pred(maxkillers)*sizeof(Tmove));
      end;
    moves^[mc]:=cmove;
    go(board,cmove,castle);
    turn:=not turn;
    inc(mc);
  until keypressed;   
  done;
end;

begin
  setup(board);
  wtime:=0;
  btime:=0;
  clrscr;
  write('How many players: ');
  readln(i);
  if i=1 then humancomp
  else if i=0 then compcomp;
end.
